// Main JellyMark code
// (C)1997-2002 Daniele Paccaloni (DDT/HBT)
// Version: 0.9b
// Sorry, haven't got time to arrange the source !
// This code is under the GNU GPL License on SourceForge.net
//   see http://sourceforge.net/projects/jellymark/

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <glh/GL/glext.h>

#include "simDefs.h"
#include "simObj.h"

#include "3dsload.h"

#include "tga.h"

#define DEBUGM 2
#define DP printf("ok!\n");

unsigned char *Texture_DecodeTGA(char *,int *,int *);

unsigned char *imagedata[6];

float	scale_factor = 8.0f;

PROC	Acc_BindTexture;
PROC	Acc_GenTextures;
PROC	Acc_DeleteTextures;

//Protoz
void printErr();
void processNormalKeys(unsigned char key, int x, int y);
int isExtensionSupported(const char *extension);
int  simInitWorld(char *name);
void simDrawConn(int oid);
void simDrawPolys(int oid);
void simDrawForces();
int simAddObject(char *name, int flags);
long simAddPForce(double cx, double cy, double cz, double mradius, int mstatus, double fstrength);
long simAddFForce(double fx, double fy, double fz, int mstatus);
int simAddHairObj(float cx, float cy, float cz, float mr_y, float Mr_y, float mr_z, float Mr_z, int numCapelli, int numSegments, float length);
int simAddCubeObj(float cx, float cy, float cz, float l, double ks, double kd, int mode, DWORD f_mask, int matid);
int simAddSheetObj(float cx, float cy, float cz, float l, int nsq1, int nsq2, double ks, double kd, int mode, DWORD f_mask, int matid);
int simAddMass(int oid, mass **mp);
int simAddConn(int oid, int *carr, int arrsize);
int simAddPoly(int oid, int mid0, int mid1, int mid2, double *n0, double *n1, double *n2, int status, poly **pp, int matid);
int simAddSpring(int oid, int mid0, int mid1, double l, double ks, double kd, int status);
int simAddMat(float *amb, float *dif, float *spe, float *emi, float shi, int status);
int simSetBCube(float cx, float cy, float cz, float l, int mode, int matid);
void simSetObjMat(int oid, int matid);
void simClearAccel(int oid);
void simApplyForces(int oid);
void simApplySprings(int oid);
void simFindVel(int oid);
void simFindPos(int oid);
void simTraslBCube(double tx, double ty, double tz);
void simRotBCube(double rx, double ry, double rz);
void simTraslObj(int oid, double tx, double ty, double tz);
void simRotObj(int oid, double rx, double ry, double rz);
void simFindSNorm(int oid);
void simFindVNorm(int oid);
H3dsScene *simLoad3DS(char *filename);
simFree3DS(H3dsScene *h3dss);
int simConv3DSObj(int addoid, H3dsScene *h3dss, int objnum, double tx, double ty, double tz, double scale, double ks, double kd, double minl, double maxl, int mode, DWORD f_mask);
//
void GenTexts( void );


void NextFrame();
void display(void);
void myReshape(int w, int h);
void initCubeMap(void);

// Application stuff
char *progname = "JellyMark v0.9 (daniele.paccaloni@dylogic.com)";
int debug = 0;
int oid_main_;

// GLUT stuff
int win_top;
int w_ = 0;
int h_ = 0;

// Misc vars
int n, i, x;

// Allocate Cube Map (6 128x128 RGBA faces)
GLubyte cubemap_[6][256][256][4];

// SIM: WORLD stuff ---------------------------------------

World world;      // Create a world.
long simtime = 0;      // Simulated frame (millis)
long dt = 30;          // Last frame dt (millis)
float scale = 1;
double crest = 1;        // Constant of restitution
double cfrict = 0;       // Constant of friction
double rbcx = 0;  // BCube rot
double rbcy = 0;
double rbcz = 0;

double	oldrbcx = 0;
double	oldrbcy = 0;
double	oldrbcz = 0;

float	tx = 0;
float	ty = -5.0f;
float	tz = 0;

int autorot = 2;

GLfloat mat_default[] = {1.0, 1.0, 1.0, 1.0};
GLfloat mat_forcep[] = {1.0, 0.0, 0.0, 1.0};
GLfloat mat_forcem[] = {0.0, 0.0, 0.5, 1.0};
GLfloat mat_conns[] = {1.0, 1.0, 0.0, 1.0};


// SIMULATED WORLD stuff ---------------------------------------

#define MAXMASS 10000
#define MAXSPRI 10000
#define MAXCONN 50000

// KEY OBJECTS
mass   headmass;
mass   *head_mp = &headmass;



// OpenGL vars -----------------------------------------------
int hdc;
int hdcD;
HWND hwndD;
HGLRC hglrcSrc;
HGLRC hglrcDst;

int spinx = 0;
int spiny = 0;
int spinz = 0;

char strbuf[256];

long lfs, lfm;


// System & Performance monitoring ------------------------------------

SYSTEM_INFO   inf;

LARGE_INTEGER sysFreqQuery;
LONGLONG sysFreq;

LARGE_INTEGER timeTmp0;
LARGE_INTEGER timeTmp1;

LONGLONG time0;
LONGLONG time1;
LONGLONG time2;
LONGLONG time3;
LONGLONG time4;
LONGLONG time5;
LONGLONG time6;

double totalTime;

double time0f = 0;
double time1f = 0;
double time2f = 0;
double time3f = 0;
double time4f = 0;
double time5f = 0;
double time6f = 0;

//==========================================================
//                    START OF CODE
//==========================================================

//------------------ USER INPUT HANDLERS ------------------

void mousemotion(int x, int y)
{
  spiny = -((w_ >> 1) - x);
  spinx = -((h_ >> 1) - y);
}

void processNormalKeys(unsigned char key, int x, int y) {
  Obj* obj;
	
  if (key == 27) exit(0);
  key |= 0x20;
  if (key == 'e') {
    printf("Toggling cube environment mapping mode.\n");
    obj = &(world.obj[oid_main_]);
    obj->flags ^= S_ENVCUBE;
  }
  else if (key == 's') {
    printf("Toggling gouraud shading.\n");
    obj = &(world.obj[oid_main_]);
    obj->flags ^= S_DRAWSMOOTH;
  }
}


//------------------ OPENGL ENVIRONMENT INIT ------------------

void myinit(void)
{
  // Default setup
  GLfloat mat_specular[] = {1.0, 1.0, 1.0, 1.0};
  GLfloat mat_shininess[] = { 128.0 };
  GLfloat light_position[] = { 0.0, -50, 20.0, 0.0};
  GLfloat light_ambient[] = { 1.0, 1.0, 1.0, 1.0};
  glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
  //glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
  //glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);
  glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glDepthFunc(GL_LEQUAL);
  glEnable(GL_DEPTH_TEST);
  glShadeModel(GL_SMOOTH);
  glFrontFace(GL_CW);
  // Init Cube Map
  initCubeMap();
}

//------------------ OPENGL RENDER FUNCTION ------------------

void display(void)
{
  
  GLfloat light_position[] = { 0.0, 1.0, 35.0, 10.0};
  
  QueryPerformanceCounter(&timeTmp0);

  // Clear GL buffers
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  QueryPerformanceCounter(&timeTmp1);
  time3 = timeTmp1.QuadPart - timeTmp0.QuadPart;

  // Infinite viewpoiny
  glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
  // 2side lighting
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
  
  // ARGH! Remove if no scaling required
  glEnable(GL_NORMALIZE);
  //glScalef(scale,scale,scale);
  //glScalef(.2, .2, .1);
  
  
  /*
  glPushMatrix();
  glTranslatef( -100.0f, -30.0f, cfrict * 25 );
  glRotatef( 90.0f, 1.0f, 0.0f, 0.0f );
  auxSolidBox( 12.0f , cfrict * 50.0f, 12.0f );
  glPopMatrix();
  
    glPushMatrix();
    glTranslatef( 100.0f, -30.0f, crest * 25 );
    glRotatef( 90.0f, 1.0f, 0.0f, 0.0f );
    auxSolidBox( 12.0f ,  crest * 50.0f, 12.0f );
    glPopMatrix();
  */
  
  glShadeModel(GL_SMOOTH);
  glEnable(GL_LIGHTING);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glPushMatrix();
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);
  glPopMatrix();
  //glRotatef( 90.0f, 1.0f, 0.0f, 0.0f );
  //glScalef(.2, .2, .1);
  glTranslatef( 0.0f, 0.0f, -6.0f * scale_factor);
  //glutSolidTeapot(20.0f);
  //auxTeapot(2);
  //glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_default);
  //auxSolidCube(1);
  
  // Render physical objects
  //printf("Nobj=%d\n", world.num_obj);
  for (n=0; n < world.num_obj; n++) {
    //simDrawForces();
    simDrawPolys(n);
    simDrawConn(n);
  }
  
  //glPopMatrix();
  //glScalef
  // Flush gl data
  //glFlush();
  //wglSwapLayerBuffers(hdc, WGL_SWAP_MAIN_PLANE);
  QueryPerformanceCounter(&timeTmp0);
  time4 = timeTmp0.QuadPart - timeTmp1.QuadPart;

  // Flush GL pipes
  glFlush();

  // Compute timings
  totalTime = time0f + time1f + time2f + time3f + time4f + time5f + time6f;

  time0f = (totalTime / time0) / sysFreq;

  glutSwapBuffers();
  //QueryPerformanceCounter(&timeTmp0);
  //time4 = timeTmp0.QuadPart - timeTmp1.QuadPart;
}

//------------------ RESHAPE WINDOW ------------------

void myReshape(int w, int h)
{
  GLfloat fl = 1.0f;

  w_ = w;
  h_ = h;
  
  //printf("My reshape!\n");
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //gluLookAt(0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0,-1.0, 0.0);

  if (w <= h) glFrustum(-fl, fl, -fl*(GLfloat)h/(GLfloat)w, fl*(GLfloat)h/(GLfloat)w, 2.0f, 10.0f*scale_factor);
  else glFrustum(-fl*(GLfloat)w/(GLfloat)h, fl*(GLfloat)w/(GLfloat)h, -fl, fl, 2.0f, 10.0f*scale_factor);
}


//------------------ CALCULATE NEXT FRAME ------------------

void NextFrame()
{
  //float			DynaX, DynaY, DynaZ;
  float			ParDTOffsetX = 0.0f, ParDTOffsetY = 0.0f, ParDTOffsetZ = -15.0f;
  unsigned int    mdata = 0;
  
  //_ftime(&tbstart);
  
  // Read Dynasight data and update viewer position
  /*
  DynaX*=100.0f;
  DynaY*=100.0f;
  DynaZ*=100.0f;
  
    DynaX += ParDTOffsetX;
    DynaY += ParDTOffsetY;
    DynaZ += ParDTOffsetZ;
  */
  //VIP_setuserposcenter(DynaX,-(DynaZ-VIP_TABLEH/2.0f),DynaY);
  
  
  // Simulated time (millis)
  simtime = simtime + dt;
  
  // Reset performance timers
  time0 = time1 = time2 = 0;

  // Physical simulation
  for (n=0; n < world.num_obj; n++) {
    rbcx += ((float) spinx) / 10000.0f;
    rbcy += ((float) spiny) / 10000.0f;
    
    /*
    mdata.p[0] = mdata.p[1] = mdata.p[2] = 0.0f;
    mdata.a[0] = mdata.a[1] = mdata.a[2] = 0.0f;
    */
    /*
    if( mdata.button & MAG_BUTTON5 )
    {
    cfrict -= 0.1f;
    if( cfrict <= 0.0f )
    cfrict = 0.1f;
    }
    else if( mdata.button & MAG_BUTTON1 )
    {
    cfrict += 0.1f;
    if( cfrict >= 1.0f )
    cfrict = 1.0f;
    }
    
      if( mdata.button & MAG_BUTTON6 )
      {
      crest -= 0.5f;
      if( crest <= 0.5f )
      crest = 0.5f;
      }
      else if( mdata.button & MAG_BUTTON2 )
      {
      crest += 0.1f;
      if( crest >= 1.0f )
      crest = 1.0f;
      }
      
        if( mdata.button & MAG_BUTTON4 )
        autorot = 1;
        else if( mdata.button & MAG_BUTTON8 )
        autorot = 2;
        else if( mdata.button & MAG_BUTTON3 )
        autorot = 0;
        
          simTraslBCube( mdata.p[0], mdata.p[2], -mdata.p[1]);
          
            autorot = 2;
            switch( autorot )
            {
            
              case 0:
              oldrbcx = mdata.a[0];
              oldrbcy = mdata.a[1];
              oldrbcz = mdata.a[2];
              
                rbcx += mdata.a[0];
                rbcy += mdata.a[1];
                rbcz += mdata.a[2];	
                break;
                
                  case 1:
                  rbcx += oldrbcx;
                  rbcy += oldrbcy;
                  rbcz += oldrbcz;
                  break;
                  
                    case 2:
                    rbcx += .004;
                    rbcy += .002;
                    rbcz +=	.001;
                    break;
                    }
    */
    simRotBCube(rbcx, rbcy, rbcz);  // Rotate bounding cube
    QueryPerformanceCounter(&timeTmp0);
    simClearAccel(n);               // Clear accelerations
    simApplyForces(n);              // Apply all forces
    QueryPerformanceCounter(&timeTmp1);
    time0 += timeTmp1.QuadPart - timeTmp0.QuadPart;
    simApplySprings(n);             // Apply all springs
    QueryPerformanceCounter(&timeTmp0);
    time1 += timeTmp0.QuadPart - timeTmp1.QuadPart;
    simFindVel(n);                  // Find all velocities
    simFindPos(n);                  // Find all positions (and check BCube)
    QueryPerformanceCounter(&timeTmp1);
    time2 += timeTmp1.QuadPart - timeTmp0.QuadPart;
  }
  
  //VIP_render( );
  /*
  _ftime(&tbend);
  lfs = tbend.time-tbstart.time;
  lfm = tbend.millitm-tbstart.millitm;
  sprintf(strbuf, "%s! D.Paccaloni -- LFT: %03d.%03hu sec    simtime = %d       ", progname, lfs, lfm, simtime);
  TextOut(hdcD, 0, 0, strbuf, strlen(strbuf));
  */
  //  getch();
  //display();
  glutPostRedisplay();
  
}

//------------------ MAIN ------------------

int main(void)
{
  int argc;
  char *argv[1];
  
  int fid, fg;
  int oid;
  float	spos[3];
  H3dsScene *scene3ds;
  // Test material
  int t_matid0 = 0;
  int t_matid1 = 0;
  float amb0[4] = {0.1f, 0.1f, 0.1f, 1.0f};
  float dif0[4] = {0.4f, 0.4f, 0.4f, 1.0f};
  float spe0[4] = {1.0f, 1.0f, 1.0f, 1.0f};
  float emi0[4] = {0.0f, 0.0f, 0.0f, 1.0f};
  float shi0 = 8.0f;
  float amb1[4] = {0.1f, 0.1f, 0.0f, 1.0f};
  float dif1[4] = {0.3f, 0.3f, 0.0f, 1.0f};
  float spe1[4] = {1.0f, 1.0f, 0.0f, 1.0f};
  float emi1[4] = {0.0f, 0.0f, 0.0f, 1.0f};
  float shi1 = 8.0;
  // Misc vars
  int i;
  

  // System & Performance init
  GetSystemInfo(&inf);


  
  debug = DEBUGM;
  
  hwndD = GetDesktopWindow();
  hdcD = GetWindowDC(hwndD);
  
  printf("JellyMark. A physical demo.\n");
  printf("(C)1998-2002 Daniele Paccaloni (daniele.paccaloni@dylogic.com)\n");
  printf("Number of CPU: %d\n", inf.dwNumberOfProcessors);
  if (inf.dwNumberOfProcessors > 1) {
    printf("*INFO* SMP support is not yet available.\n");
  }
  printf("Core using 1 thread.\n");
  if (debug) printf("Initializing physical objects...\n");
  // Init World
  if (!simInitWorld("Hello_World")) {
    printf("%s: ***PANIC*** simInitWorld() FAILED.\nABORTING.\n", progname);
    exit(1);
  }
  t_matid0 = simAddMat(amb0, dif0, spe0, emi0, shi0, S_ALIVE);
  t_matid1 = simAddMat(amb1, dif1, spe1, emi1, shi1, S_ALIVE);
  /*
  conns[0] = -2;
  cur_mp = masses;
  cur_sp = springs;
  cur_m = 0;
  cur_s = 0;
  cur_c = 0;
  */
  // Initialize forces
  // Add Gravity
  fg = simAddFForce(0.0, -9.8/1000, 0.0, 0);
  // Add an attractive force
  //fid = simAddPForce(-2.0,2.0,-3.0, 30.0, S_FIXED, -.01);
  
  // Set Bounding Cube
  simSetBCube(0, 0, 0, 4.0*scale_factor, M_GENPOLYS | M_GENCONNS | S_DRAWSMOOTH | S_FIXED, t_matid0);
  // Create Hair
  //simAddHairObj(ptsk[eTesta][0], ptsk[eTesta][1], ptsk[eTesta][2], 0.0, PI,  0.0, 2*PI, 200, 10, 1.0);
  
  // Create a cube
  //simAddCubeObj(0,2,0, 1, 130,10, M_GENSPRINGS | M_GENPOLYS | S_ALIVE | S_AUTONORMV | S_DRAWSMOOTH | S_BUMPBC, F_GRAVITY, t_matid);
  //simAddCubeObj(0,2,2, 1.5*scale_factor, 130,10, M_GENSPRINGS | M_GENPOLYS | S_ALIVE | S_AUTONORMV | S_DRAWSMOOTH | S_BUMPBC, F_GRAVITY, t_matid);
  
  // Create a sheet
  //simAddSheetObj(0,-0.3*scale_factor,0, .1*scale_factor, 40,40, 70,20, M_GENSPRINGS | M_GENPOLYS | S_ALIVE | S_AUTONORMV | S_BUMPBC | S_DRAWSMOOTH /*| S_ENVCUBE */, F_GRAVITY, t_matid0);
  
  /*
  // Load 3ds scene
  scene3ds = simLoad3DS("3ds\\skingobl.3ds");
  if (scene3ds == NULL) {
  printf("%s: ***PANIC*** simLoad3DS() FAILED.\nABORTING.\n", progname);
  exit(1);
  }
  // Convert loaded 3DS object 0
  for (i=0; i<(scene3ds->meshobjs); i++) {
  //simConv3DSObj(scene3ds, i, 2,30,2, 4, 40, 5, S_BUMPGND | M_GENSPRINGS | M_GENPOLYS | S_DRAWSMOOTH | S_AUTONORMV | S_CULLBACK, F_GRAVITY);
  simConv3DSObj(-1, scene3ds, i,0,5,-3, .015 * scale_factor, 20,5, 3.5, S_BUMPBC | M_GENSPRINGS | M_GENPOLYS | S_DRAWSMOOTH | S_AUTONORMV | S_CULLBACK, F_GRAVITY);
  }
  */
  // Load 3ds scene
  /*
  scene3ds = simLoad3DS("..\\3ds\\thing.3ds");
  if (scene3ds == NULL) {
    printf("%s: *** ERROR *** simLoad3DS() FAILED to load scene.\n", progname);
    printf("%s: ABORTING.\n", progname);
    exit(1);
  }
  // Convert loaded 3DS object
  for (i=0; i<(scene3ds->meshobjs); i++) {
    //oid = simConv3DSObj(-1, scene3ds, i, 0,0,0, .01*scale_factor, 20,5, 2.5, S_BUMPBC | M_GENSPRINGS | M_GENPOLYS | S_AUTONORMV | S_CULLBACK | S_ENVCUBE, F_GRAVITY);
  }
  //simSetObjMat(oid, t_matid1);
  */
  
  // Load 3ds scene
  scene3ds = simLoad3DS("bmoon1m.3ds");
  if (scene3ds == NULL) {
    printf("%s: *** ERROR *** simLoad3DS() FAILED to load scene.\n", progname);
    printf("%s: ABORTING.\n", progname);
    exit(1);
  }
  // Convert loaded 3DS object
  for (i=0; i<(scene3ds->meshobjs); i++) {
    printf("simConv3DSObj: Physicalizing object...\n");
    oid = simConv3DSObj(-1, scene3ds, i, 0,0,0, .3*scale_factor, 5,1, 0.00*scale_factor, 0.15*scale_factor, S_BUMPBC | M_GENSPRINGS | M_GENPOLYS | S_DRAWSMOOTH | S_AUTONORMV | S_CULLBACK | S_ENVCUBE, F_GRAVITY);
    oid_main_ = oid;
    simRotObj(oid, 0, 1.3, 0);
    //oid = simConv3DSObj(-1, scene3ds, i, 0,15,3, 3*scale_factor, 20,5, 10, S_BUMPBC | M_GENSPRINGS | M_GENPOLYS | S_AUTONORMS | S_CULLBACK, F_GRAVITY);
  }
  simSetObjMat(oid, t_matid0);
  // ..rest of init..
  //if (debug > 1) printf("  Masses:%d  Springs:%d  Forces:%d Connections+tags:%d\n", num_masses, num_springs, num_forces, num_conns);
  
  // End of phisics init
  
  if (debug) printf("Initializing OpenGL rendering engine...\n");
  hdc = wglGetCurrentDC();
  // Print OGL driver info
  //printf("  OGL info:\n");
  //printf("    Vendor:     %s\n", glGetString(GL_VENDOR));
  //printf("    Renderer:   %s\n", glGetString(GL_RENDERER));
  //printf("    Version:    %s\n", glGetString(GL_VERSION));
  //printf("    Extensions: %s\n", glGetString(GL_EXTENSIONS));
  
  //VIP_init(1280, 1024, VIP_STEREO_DOUBLEWINDOW, 21);
  //VIP_init(1024, 768, VIP_STEREO_DOUBLEWINDOW, 21);
  
  
  
  //VIP_setCallback(VIP_WM_PAINT, display, NULL);
  //VIP_setCallback(VIP_WM_KEYDOWN, HandleKey, NULL);
  
  //VIP_setActions(NextFrame, NULL);
  
  // Init system font for gl printing
  //SelectObject(hdc, GetStockObject(SYSTEM_FONT)); 
  //wglUseFontBitmaps (hdc, 0, 255, 1000); 
  argc = 1;
  argv[0] = "WinJelly";
  glutInit(&argc, argv);
  
  glutInitWindowPosition(0, 0);
  glutInitWindowSize(500, 600);
  // Display mode
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
  // Create toplevel win
  win_top = glutCreateWindow(progname);
  // Set win and icon titles
  glutSetWindowTitle(progname);
  glutSetIconTitle(progname);
  // Set myReshape function
  glutReshapeFunc(myReshape);
  // Set display function
  glutDisplayFunc(display);
  // Set idle function
  glutIdleFunc(NextFrame);
  // Set cursor
  glutSetCursor(GLUT_CURSOR_CROSSHAIR);
  // Set mouse buttons callback
  //glutMouseFunc(mousefunc);
  // Set mouse motion callback
  glutMotionFunc(mousemotion);
  // Set keyboard callback
  glutKeyboardFunc(processNormalKeys);
  
  // Init gfx
  myinit();
  GenTexts();

  // Init cubemap
  initCubeMap();
  
  // Get system timer resolution
  QueryPerformanceFrequency(&sysFreqQuery);
  sysFreq = sysFreqQuery.QuadPart;
  printf("Sys performance timer freq: %d Hz\n", sysFreq);

  // Print info
  printf("\n");
  printf("Use the mouse to rotate the cube.\n");
  printf("\n");
  printf("Keys:\n");
  printf(" e: Toggle Cube Environment Mapping.\n");
  printf(" s: Toggle Flat/Gouraud.\n");
  //printf(" o: Toggle Object.\n");

  glutMainLoop();
  
  if (debug) printf("Exiting.\n");
  return 0;
}

//------------------ PRINT ERROR ------------------

void printErr()
{
  LPVOID lpMsgBuf;
  
  FormatMessage( 
    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
    NULL,
    GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL 
    );
  
  // Display the string.
  MessageBox( NULL, lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );
  
  // Free the buffer.
  LocalFree( lpMsgBuf );
}


//------------------ SIM: simLoad3DS ------------------
// Load a 3DS scene
H3dsScene *simLoad3DS(char *filename)
{
  H3dsScene *h3dss;
  
  h3dss = load3ds(filename);
  if (h3dss == NULL) return NULL;
  if (debug) printf("  simLoad3DS(): Loaded scene contains %d objects.\n", h3dss->meshobjs);
  return h3dss;
}

//------------------ SIM: simFree3DS ------------------
// Free a 3DS scene
simFree3DS(H3dsScene *h3dss)
{
  if (debug) printf("  simFree3DS(): Freeing 3DS scene.\n");
  HFree3dsScene(h3dss);
}


//------------------ SIM: simConv3DSobj ------------------
// Convert an object from a 3DS scene
// Return: oid on success
//          -1 on error
int simConv3DSObj(int addoid, H3dsScene *h3dss, int objnum, double tx, double ty, double tz, double scale, double ks, double kd, double minl, double maxl, int mode, DWORD f_mask)
{
  Obj *obj;
  int oid;
  mass *m;
  int mid[3];
  material *mat;
  int matid;
  poly *p;
  float amb[4] = {0.2f, 0.2f, 0.2f, 1.0f};
  float dif[4] = {0.8f, 0.8f, 0.8f, 1.0f};
  float spe[4] = {0.0f, 0.0f, 0.0f, 1.0f};
  double l;
  double x0, y0, z0;
  double x1, y1, z1;
  double x2, y2, z2;
  int sid;
  int conns[3];
  H3dsMeshObj *meshobj;
  char *oname;
  int nfaces;
  int nverts;
  int nmatsb;
  int voffset;
  H3dsFace *flist, *f;
  H3dsVert *vlist, *v;
  H3dsMatList *hmatlist, *hmatl;
  H3dsMat *hmat;
  int nmats;
  int mfound;
  int i, j, n;
  word vn, fn;
  word *faces;
  int status;
  
  if (mode && S_ENVCUBE) {
    // Check if ENV mapping is available
    int rc = isExtensionSupported("GL_ARB_texture_cube_map");
    if (rc == -1) printf("*** WARNING *** Couldn't check OpenGL extensions.\n");
    else if (rc == 0) {
      printf("*** WARNING *** Cube environment mapping is not supported and has been disabled.\n");
      mode &= ~S_ENVCUBE;
    }
  }

  status = mode | S_ALIVE;
  
  meshobj = (h3dss->meshobjlist) + objnum;
  
  oname = meshobj->name;
  if (debug) printf("  simConv3DSobj(): Converting object \"%s\"\n", oname);
  
  // Check if a new object is requested
  if (addoid == -1) {
    oid = simAddObject(oname, status);
    //oid = simAddObject(oname, S_ALIVE | S_AUTONORMS);
    if (oid == -1) return -1;
  }
  else {
    oid = addoid;
  }
  
  obj = &(world.obj[oid]);
  
  nfaces = meshobj->NumFaces;
  nverts = meshobj->NumVerts;
  nmatsb = meshobj->NumBindings;
  voffset = meshobj->offset;
  flist = meshobj->facelist;
  vlist = meshobj->vertlist;
  hmatlist = meshobj->bindings;
  if (debug > 1) printf("  simConv3DSobj(): %d faces, %d verts, %d mats\n", nfaces, nverts, nmatsb);
  
  for (i=0; i<nverts; i++) {
    if (simAddMass(oid, &m) == -1) return -1;
  }
  
  for (i=0; i<nfaces; i++) {
    f = flist+i;
    for (n=0; n<3; n++) {
      vn = *((word*)f+n);
      v = vlist+vn;
      if ((obj->num_masses) > vn) {
        mid[n] = (int)vn;
        m = (obj->masses)+mid[n];
        m->x = tx+scale*(v->x);
        m->y = ty+scale*(v->y);
        m->z = tz+scale*(v->z);
        m->flu = f_mask;
        m->status = status;
      }
      else {
        printf("  ***ERROR*** simConv3DSobj(): Vertex number (%d) out of range in 3DSobject %d\n", vn, objnum);
        return -1;
      }
    }
    
    // Gen surface springs
    if ((mode & M_GENSPRINGS) && (maxl==0)) {
      m = obj->masses;
      x0 = (m+mid[0])->x;
      y0 = (m+mid[0])->y;
      z0 = (m+mid[0])->z;
      x1 = (m+mid[1])->x;
      y1 = (m+mid[1])->y;
      z1 = (m+mid[1])->z;
      x2 = (m+mid[2])->x;
      y2 = (m+mid[2])->y;
      z2 = (m+mid[2])->z;
      l = sqrt((x0-x1)*(x0-x1) + (y0-y1)*(y0-y1) + (z0-z1)*(z0-z1));
      sid = simAddSpring(oid, mid[0], mid[1], l, ks, kd, S_ALIVE);
      l = sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) + (z2-z1)*(z2-z1));
      sid = simAddSpring(oid, mid[1], mid[2], l, ks, kd, S_ALIVE);
      l = sqrt((x2-x0)*(x2-x0) + (y2-y0)*(y2-y0) + (z2-z0)*(z2-z0));
      sid = simAddSpring(oid, mid[2], mid[0], l, ks, kd, S_ALIVE);
    }
    
    // Gen conns
    if (mode & M_GENCONNS) {
      conns[0] = mid[0];
      conns[1] = mid[1];
      conns[2] = mid[2];
      simAddConn(oid, conns, 3);
    }
    if (mode & M_GENPOLYS) {
      if (mode & M_3DSSWAPNORM) {
        simAddPoly(oid, mid[2], mid[1], mid[0], NULL, NULL, NULL, status, NULL, 0);
      }
      else {
        simAddPoly(oid, mid[0], mid[1], mid[2], NULL, NULL, NULL, status, NULL, 0);
      }
    }
  }
  
  // Gen springs
  m = obj->masses;
  if ((mode & M_GENSPRINGS) && (maxl!=0)) {
    for (i=0; i<(obj->num_masses); i++) {
      for (j=i+1; j<(obj->num_masses); j++) {
        //if (j == i+20) break;
        x0 = (m+i)->x;
        y0 = (m+i)->y;
        z0 = (m+i)->z;
        x1 = (m+j)->x;
        y1 = (m+j)->y;
        z1 = (m+j)->z;
        l = sqrt((x0-x1)*(x0-x1) + (y0-y1)*(y0-y1) + (z0-z1)*(z0-z1));
        if ((l<maxl*scale_factor) && (l>minl*scale_factor)) {  // Check spring max and min lenght
          sid = simAddSpring(oid, i, j, l, ks, kd, S_ALIVE);
        }
      }
    }
    if (debug > 1) printf("  simConv3DSobj(): Generated %d complete springs for obj%d\n", obj->num_springs, oid);
  }
  
  // Create and set materials
  nmats = h3dss->NumMaterials;
  for (i=0; i<nmatsb; i++) {
    hmatl = hmatlist+i;
    if (debug > 1) printf("  simConv3DSobj(): Converting material %d (\"%s\")\n", i, hmatl->name);
    hmat = h3dss->material;
    mfound = 0;
    for (j=0; j<nmats; j++) {
      //printf("---%s\n", hmat->name);
      if (!strncmp(hmatl->name, hmat->name, 16)) {
        mfound = 1;
        break;
      }
      hmat++;
    }
    if (mfound) {
      // Add new material
      amb[0] = hmat->ambient.red;
      amb[1] = hmat->ambient.green;
      amb[2] = hmat->ambient.blue;
      dif[0] = hmat->diffuse.red;
      dif[1] = hmat->diffuse.green;
      dif[2] = hmat->diffuse.blue;
      spe[0] = hmat->specular.red;
      spe[1] = hmat->specular.green;
      spe[2] = hmat->specular.blue;
      matid = simAddMat(amb, dif, spe, NULL, 128.0, S_ALIVE);
      if (matid == -1) printf("  ***ERROR*** simConv3DSobj(): simAddMaterial() failed for 3DSobject %d\n", objnum);
      // Set polys materials
      faces = (hmatl->faces);
      p = (obj->polys);
      for (j=0; j<(hmatl->NumFaces); j++) {
        n = *faces;
        //printf("face%d\n", n);
        (p+n)->matid = matid;
        faces++;
      }
    }
    else {
      if (matid == -1) printf("  ***WARNING*** simConv3DSobj(): Couldnt find material \"%s\" for 3DSobject %d\n", objnum, hmatl->name);
    }
    
  }
  
  return oid;
}


//------------------ SIM: simGenHair ------------------
// Generate hair simGenHair(numCapelli, numSegments)
/*
int simGenHair(float cx, float cy, float cz, float mr_y, float Mr_y, float mr_z, float Mr_z, int numCapelli, int numSegments, float length)
{
int k, i;
mass   *m;
spring *s;
float slen = length/numSegments;
float dx, dy, dz;
float sx, sy, sz;
float r_y, r_z;

  // Use the force, Luke! (repulsive inside head).
  simAddPForce(cx, cy-.2, cz+2, 5.0, S_FIXED, .01);
  
    // Create hair
    m = cur_mp;
    s = cur_sp;
    if (debug) printf("  simGenHair()\n");
    srand((unsigned)time(NULL));
    for (k=0; k < numCapelli; k++) {
    r_y = mr_y + rand()*(Mr_y - mr_y)/RAND_MAX;
    r_z = mr_z + rand()*(Mr_z - mr_z)/RAND_MAX;
    dy = slen*sin(r_y);
    dx = slen*cos(r_y)*cos(r_z);
    dz = slen*cos(r_y)*sin(r_z);
    //if (debug >= 2) printf("    Hair %d: dx=%f, dy=%f, dz=%f\n", k, dx, dy, dz);
    sx = cx; sy = cy; sz = cz;
    for (i=0; i < numSegments; i++) {
    simInitMass(m);
    m->x = sx;
    m->y = sy;
    m->z = sz;
    sx += dx;
    sy += dy;
    sz += dz;
    if (i > 0) {
    m->flu |= (F_GRAVITY | (1<<cur_f));
    s->ks = 500;
    s->kd = 10;
    s->m1 = (m-1);
    s->m2 = m;
    s->restlen = slen;
    s->status = S_ALIVE;
    //if (i==1) {
    //  s->m1 = head_mp;
    //  head_mp->x = cx;
    //  head_mp->x = cy;
    //  head_mp->x = cz;
    //}
    s++;
    cur_s++;
    conns[cur_c++] = cur_m-1;
    conns[cur_c++] = cur_m;
    conns[cur_c++] = -1;
    }
    else {
    m->status = S_FIXED;
    }
    m++;
    cur_m++;
    }
    }
    cur_mp = m;
    cur_sp = s;
    return 0;
    }
    */
    
    
    //------------------ SIM: simAddConn ------------------
    // Add a new connection array to specified object
    // Return:  0 on success
    //         -1  on error
    
    int simAddConn(int oid, int *carr, int arrsize)
    {
      Obj *obj;
      int mid;
      int *cr;
      int n;
      
      obj = &(world.obj[oid]);
      if (arrsize < 1) {
        printf("  *** ERROR *** simAddConn(): Invalid array size (oid=%d).\n", oid);
        return -1;
      }
      
      if ((obj->all_conns - obj->num_conns - arrsize - 1) <= 0) {
        n = sizeof(int) * (obj->all_conns + ALL_CONNS);
        if (debug > 2) printf("  simAddConn(): Expanding size of conns structure for obj%d to %d\n", oid, n);
        cr = (int*)malloc(n);
        if (cr == NULL) {
          printf("  *** ERROR *** simAddConn(): Failed malloc(%d). (oid=%d).\n", n, oid);
          return -1;
        }
        memcpy(cr, obj->conns, (obj->all_conns)*sizeof(int));
        free(obj->conns);
        obj->conns = cr;
        obj->all_conns += ALL_CONNS;
        obj->num_conns = 1;
      }
      //printf("obj%d all_conns = %d\n", oid, obj->all_conns);
      
      cr = (obj->conns) + (obj->num_conns) - 1;  // Remove last endofconns (-2)
      
      obj->num_conns += (arrsize + 1);
      
      
      memcpy(cr, carr, sizeof(int)*arrsize);
      cr += arrsize;
      *cr = -1; // End of this connection
      cr++;
      *cr = -2; // End of conns
      
      //printf("numconns=%d\n", obj->num_conns);
      return 0;
    }
    
    
    //------------------ SIM: simAddMass ------------------
    // Add a new mass to specified object
    // Return: mid on success
    //         -1  on error
    
    int simAddMass(int oid, mass **mp)
    {
      Obj *obj;
      int mid;
      mass *mr;
      int n;
      
      obj = &(world.obj[oid]);
      
      if ((obj->all_masses - obj->num_masses) <= 0) {
        n = sizeof(mass) * (obj->all_masses + ALL_MASSES);
        if (debug > 2) printf("  simAddMass(): Expanding size of masses structure for obj%d to %d\n", oid, n);
        mr = (mass*)malloc(n);
        if (mr == NULL) {
          printf("  *** ERROR *** simAddMass(): Failed malloc(%d) for masses (oid=%d).\n", n, oid);
          return -1;
        }
        memcpy(mr, obj->masses, (obj->all_masses)*sizeof(mass));
        free(obj->masses);
        obj->masses = mr;
        obj->all_masses += ALL_MASSES;
      }
      //printf("obj%d all_masses = %d\n", oid, obj->all_masses);
      
      mid = obj->num_masses;
      obj->num_masses += 1;
      
      mr = obj->masses + mid;
      if (mp != NULL) *mp = mr;
      mr->x = 0;
      mr->y = 0;
      mr->z = 0;
      mr->vx = 0;
      mr->vy = 0;
      mr->vz = 0;
      mr->ax = 0;
      mr->ay = 0;
      mr->az = 0;
      mr->nx = 0;
      mr->ny = 0;
      mr->nz = 0;
      mr->npolys = 0;
      mr->mass = 1;
      mr->elastic = 1;
      mr->radius = 0.1;
      mr->status = S_ALIVE;
      mr->flu = -1;             // Default is influenced by all forces
      
      return mid;
    }
    
    
    //------------------ SIM: simAddMat ------------------
    // Add a new material to the world
    // Return: matid on success
    //         -1  on error
    int simAddMat(float *amb, float *dif, float *spe, float *emi, float shi, int status)
    {
      int matid;
      material *mat;
      float defamb[4] = {0.2, 0.2, 0.2, 1.0};
      float defdif[4] = {0.8, 0.8, 0.8, 1.0};
      float defspe[4] = {0.0, 0.0, 0.0, 1.0};
      float defemi[4] = {0.0, 0.0, 0.0, 1.0};
      
      if (world.num_mat == MAXMATERIALS) return -1;
      
      matid = world.num_mat;
      world.num_mat++;
      
      if (debug > 1) printf("  simAddMat(): Added material (id=%d)\n", matid);
      
      mat = &(world.mats[matid]);
      
      if (amb != NULL) memcpy(&(mat->amb_R), amb, 3*sizeof(float));
      else memcpy(&(mat->amb_R), defamb, 3*sizeof(float));
      if (dif != NULL) memcpy(&(mat->dif_R), dif, 3*sizeof(float));
      else memcpy(&(mat->dif_R), defdif, 3*sizeof(float));
      if (spe != NULL) memcpy(&(mat->spe_R), spe, 3*sizeof(float));
      else memcpy(&(mat->spe_R), defspe, 3*sizeof(float));
      if (emi != NULL) memcpy(&(mat->emi_R), emi, 3*sizeof(float));
      else memcpy(&(mat->emi_R), defemi, 3*sizeof(float));
      mat->shi = shi;
      mat->status = status;
      
      return matid;
    }
    
    
    //------------------ SIM: simSetObjMat ------------------
    // Set all polys of an object with the specified material
    void simSetObjMat(int oid, int matid)
    {
      Obj *obj;
      poly *p;
      int n;
      
      obj = &(world.obj[oid]);
      
      p = obj->polys;
      for(n=0; n<(obj->num_polys); n++)
      {
        p->matid = matid;
        p++;
      }
      
    }
    
    
    //------------------ SIM: simAddPoly ------------------
    // Add a new poly to specified object
    // Return: pid on success
    //         -1  on error
    
    int simAddPoly(int oid, int mid0, int mid1, int mid2, double *n0, double *n1, double *n2, int status, poly **pp, int matid)
    {
      Obj *obj;
      int pid;
      poly *pr;
      int n;
      mass *m;
      
      obj = &(world.obj[oid]);
      
      if ((obj->all_polys - obj->num_polys) <= 0) {
        n = sizeof(poly) * (obj->all_polys + ALL_POLYS);
        if (debug > 2) printf("  simAddPoly(): Expanding size of polys structure for obj%d to %d\n", oid, n);
        pr = (poly*)malloc(n);
        if (pr == NULL) {
          printf("  *** ERROR *** simAddPoly(): Failed malloc(%d) for polys (oid=%d).\n", n, oid);
          return -1;
        }
        memcpy(pr, obj->polys, (obj->all_polys)*sizeof(poly));
        free(obj->polys);
        obj->polys = pr;
        obj->all_polys += ALL_POLYS;
      }
      //printf("obj%d all_polys = %d\n", oid, obj->all_polys);
      
      pid = obj->num_polys;
      obj->num_polys += 1;
      
      pr = obj->polys + pid;
      if (pp != NULL) *pp = pr;
      pr->id = pid;
      pr->mid0 = mid0;
      pr->mid1 = mid1;
      pr->mid2 = mid2;
      //printf("---matid=%d\n", matid);
      m = obj->masses;
      ((m+mid0)->npolys)++;
      ((m+mid1)->npolys)++;
      ((m+mid2)->npolys)++;
      if (n0 != NULL) memcpy(&((m+mid0)->nx), n0, 3*sizeof(double));
      if (n1 != NULL) memcpy(&((m+mid1)->nx), n1, 3*sizeof(double));
      if (n2 != NULL) memcpy(&((m+mid1)->nx), n2, 3*sizeof(double));
      pr->status = status | S_ALIVE;
      pr->matid = matid;
      
      return pid;
    }
    
    
    
    
    //------------------ SIM: simDrawConn ------------------
    // Draw all connected points of an object
    
    void simDrawConn(int oid)
    {
      Obj *obj;
      int m;
      mass *masses, *smp;
      int *cur_cp;
      float *spoint;
      float *epoint;
      
      //printf("  simDrawConn(): oid=%d\n", oid);
      obj = &(world.obj[oid]);
      if ((obj->num_conns) <= 0) return;
      cur_cp = obj->conns;
      masses = obj->masses;
      
      /*
      m = -1;
      cur_cp = (obj->conns);
      while (m!=-2) {
      printf("m= %d\n", m);
      m = *cur_cp;
      cur_cp++;
      }
      exit(1);
      */
      
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_conns);
      glLineWidth(1);
      glShadeModel(GL_FLAT);  //FLAT MODE FOR LINEZ
      glBegin(GL_LINES);
      m = -1;
      while (m != -2) {
        //printf("%p = %d\n", cur_cp, m);
        if (m == -1) {
          while ((m = *cur_cp) == -1) cur_cp++;
          if (m == -2) break;
          smp = masses + m;
        }
        else {
          glVertex3dv(&(smp->x));
          glVertex3dv(&((masses+m)->x));
        }
        m = *cur_cp;
        //printf("m= %d\n", m);
        cur_cp++;
      }
      glEnd();
      //printf("End of draw conn\n");
    }
    
    
    //------------------ SIM: simFindSNorm ------------------
    // Find all poly surface normals for an object
    void simFindSNorm(int oid)
    {
      Obj *obj;
      int mid0, mid1, mid2;
      mass *masses;
      poly *p;
      int flags;
      int i;
      double x0, y0, z0;
      double x1, y1, z1;
      double x2, y2, z2;
      double len;
      
      int	otexto = 0;
      
      obj = &(world.obj[oid]);
      if ((obj->num_polys) <= 0) return;
      masses = obj->masses;
      p = obj->polys;
      flags = obj->flags;
      
      // Find surface normals for any poly
      for (i=0; i<(obj->num_polys); i++) {
        mid0 = p->mid0;
        mid1 = p->mid1;
        mid2 = p->mid2;
        x0 = *((double *)(masses + mid0));
        y0 = *((double *)(masses + mid0) + 1);
        z0 = *((double *)(masses + mid0) + 2);
        x1 = *((double *)(masses + mid1));
        y1 = *((double *)(masses + mid1) + 1);
        z1 = *((double *)(masses + mid1) + 2);
        x2 = *((double *)(masses + mid2));
        y2 = *((double *)(masses + mid2) + 1);
        z2 = *((double *)(masses + mid2) + 2);
        // Find normal of tri
        // v0 = v0 - v1
        x0 -= x1;
        y0 -= y1;
        z0 -= z1;
        // v1 = v1 - v2
        x1 = x1 - x2;
        y1 = y1 - y2;
        z1 = z1 - z2;
        // v2 = v0 x v1
        x2 = y0*z1 - z0*y1;
        y2 = z0*x1 - x0*z1;
        z2 = x0*y1 - y0*x1;
        // Normalize normal
        len = sqrt(x2*x2 + y2*y2 + z2*z2);
        x2 /= len;
        y2 /= len;
        z2 /= len;
        // Store new normal
        p->nx = x2;
        p->ny = y2;
        p->nz = z2;
        p++;
      }
      
    }
    
    
    //------------------ SIM: simFindVNorm ------------------
    // Find all poly mass normals for an object (must be called after simFindSNorm())
    void simFindVNorm(int oid)
    {
      Obj *obj;
      int mid0, mid1, mid2;
      mass *masses, *m;
      poly *polys, *p;
      int flags;
      int i;
      double len;
      double np;
      
      int	otexto = 0;
      
      obj = &(world.obj[oid]);
      if ((obj->num_polys) <= 0) return;
      masses = obj->masses;
      polys = obj->polys;
      flags = obj->flags;
      
      // Find vertex normal interpolating surface normals
      for (i=0; i<(obj->num_masses); i++) {
        m = masses+i;
        m->nx = 0;
        m->ny = 0;
        m->nz = 0;
      }
      for (i=0; i<(obj->num_polys); i++) {
        p = polys+i;
        mid0 = p->mid0;
        mid1 = p->mid1;
        mid2 = p->mid2;
        m = masses+mid0;
        m->nx += p->nx;
        m->ny += p->ny;
        m->nz += p->nz;
        m = masses+mid1;
        m->nx += p->nx;
        m->ny += p->ny;
        m->nz += p->nz;
        m = masses+mid2;
        m->nx += p->nx;
        m->ny += p->ny;
        m->nz += p->nz;
      }
      for (i=0; i<(obj->num_masses); i++) {
        m = masses+i;
        np = (double)(m->npolys);
        m->nx /= np;
        m->ny /= np;
        m->nz /= np;
      }
      
    }
    
    
    //------------------ SIM: simDrawPolys ------------------
    // Draw all polys of an object
    
    void simDrawPolys(int oid)
    {
      Obj *obj;
      int mid0, mid1, mid2;
      mass *masses, *m;
      poly *polys, *p;
      int matid, omatid;
      double *norm;
      float *spoint;
      float *epoint;
      int flags;
      int smooth;
      int i;
      int autonorm = 0;
      
      int	otexto = 0;

      //printf("  simDrawPolys(): oid=%d\n", oid);
      obj = &(world.obj[oid]);
      if ((obj->num_polys) <= 0) return;
      masses = obj->masses;
      polys = obj->polys;
      flags = obj->flags;
      
      // Set material
      //glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_conns);
      
      // Flat or smooth ?
      if (flags & S_DRAWSMOOTH) {
        glShadeModel(GL_SMOOTH);
        smooth = 1;
      }
      else {
        glShadeModel(GL_FLAT);
        smooth = 0;
      }
      
      // CW ?
      if (flags & S_CW) {
        glFrontFace(GL_CW);
      }
      else {
        glFrontFace(GL_CCW);
      }
      
      // Auto normals ?
      if (flags & (S_AUTONORMS | S_AUTONORMV)) {
        autonorm = 1;
        simFindSNorm(oid);
      }
      if (flags & S_AUTONORMV) {
        simFindVNorm(oid);
        autonorm = 2;
      }
      
      // Back culling ?
      if (flags & S_CULLBACK) {
        glCullFace(GL_BACK);
        glEnable(GL_CULL_FACE);
      }
      else glDisable(GL_CULL_FACE);
      
      // Draw that polys
      p = obj->polys;
      omatid = -2;
      
      if( flags & S_TEXTURED ) {
        // Textured shading
        for (i=0; i<(obj->num_polys); i++) {
          mid0 = p->mid0;
          mid1 = p->mid1;
          mid2 = p->mid2;
          matid = p->matid;
          
          if(!(i & 1)) {
            Acc_BindTexture(GL_TEXTURE_2D,world.bcube.txts[i>>1]);
            glEnable( GL_TEXTURE_2D );
            glBegin(GL_TRIANGLES);
          }
          
          if (omatid != matid) {
            omatid = matid;
            glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, &(world.mats[matid].amb_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, &(world.mats[matid].dif_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, &(world.mats[matid].spe_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, &(world.mats[matid].emi_R));
            glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, world.mats[matid].shi);
          }

          glNormal3dv(&((masses+mid0)->nx));
          glTexCoord2f(world.bcube.vm[otexto][0], 
            world.bcube.vm[otexto][1]);
          glVertex3dv(masses+mid0);
          
          glNormal3dv(&((masses+mid1)->nx));
          glTexCoord2f(world.bcube.vm[otexto+1][0], 
            world.bcube.vm[otexto+1][1]);
          glVertex3dv(masses+mid1);
          
          glNormal3dv(&((masses+mid2)->nx));
          glTexCoord2f(world.bcube.vm[otexto+2][0], 
            world.bcube.vm[otexto+2][1]);
          glVertex3dv(masses+mid2);

          p++;
          
          //otexto = (otexto + 3) % 6;
          otexto += 3;
          
          if( i & 1 ) glEnd();
        }
        
      } 
      else if( flags & S_ENVCUBE ) {
        // Cube Env Map shading
        int cmsize = 0;
        //glSet(GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT, 64);
        //glGetIntegerv(GL_CUBE_MAP_TEXTURE_SIZE_EXT, &cmsize);
        //printf("*************GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT = %d", cmsize);
        initCubeMap();
        // Enable CubeMap
        glDisable(GL_TEXTURE_2D);
        glEnable(GL_TEXTURE_CUBE_MAP_ARB);
      glTexParameterf(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
      glTexParameterf(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
      glTexParameterf(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
      //glTexParameterf(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
      glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_GENERATE_MIPMAP_SGIS, GL_TRUE);
      //glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      //glCopyTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT + I, 0, GL_RGB, 0, 0, PBUF_SIZE, PBUF_SIZE, 0);
        // The reflection map mode can be enabled like this
        glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_EXT);
        glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_EXT);
        glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_EXT);
        //glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_EXT);
        //glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_EXT);
        //glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_EXT);
        glEnable(GL_TEXTURE_GEN_S);
        glEnable(GL_TEXTURE_GEN_T);
        glEnable(GL_TEXTURE_GEN_R);
        //glEnable(GL_TEXTURE_GEN_Q);
        Acc_BindTexture(GL_TEXTURE_CUBE_MAP_ARB, cubemap_);
      glMatrixMode(GL_TEXTURE);
        glPushMatrix();
        glLoadIdentity();
        glRotatef(-rbcx * 180 / PI, 1.0f, 0.0f, 0.0f); 
        glRotatef(-rbcy * 180 / PI, 0.0f, 1.0f, 0.0f);
        glRotatef(-rbcz * 180 / PI, 0.0f, 0.0f, 1.0f);
        glTranslatef( 0.0f, 0.0f, 0.0f );
        glScalef( 1.0f, 1.0f, 0.032f*scale_factor );
        //glScalef(scale_factor, scale_factor, scale_factor);
      glMatrixMode(GL_MODELVIEW);
        // The normal map mode can be enabled like this
        /*
        glTexGenfv(GL_S, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_EXT);
        glTexGenfv(GL_T, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_EXT);
        glTexGenfv(GL_R, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_EXT);
        glEnable(GL_TEXTURE_GEN_S);
        glEnable(GL_TEXTURE_GEN_T);
        glEnable(GL_TEXTURE_GEN_R);
        */
        for (i=0; i<(obj->num_polys); i++) {
          mid0 = p->mid0;
          mid1 = p->mid1;
          mid2 = p->mid2;
          matid = p->matid;
          
          glBegin(GL_TRIANGLES);
          
          if (omatid != matid) {
            omatid = matid;
            glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, &(world.mats[matid].amb_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, &(world.mats[matid].dif_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, &(world.mats[matid].spe_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, &(world.mats[matid].emi_R));
            glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, world.mats[matid].shi);
          }
          glNormal3dv(&((masses+mid0)->nx));
          //glTexCoord2f(world.bcube.vm[otexto][0], 
          //  world.bcube.vm[otexto][1]);
          //glVertex3dv(masses+mid0);
          //glTexCoord3f(s,t,r); /* user-supplied direction vector for cube map texturing */
          glTexCoord3dv(&((masses+mid0)->nx));
          //glVertex3f(x,y,z);
          glVertex3dv(masses+mid0);
          
          glNormal3dv(&((masses+mid1)->nx));
          //glTexCoord2f(world.bcube.vm[otexto+1][0], 
          //  world.bcube.vm[otexto+1][1]);
          //glVertex3dv(masses+mid1);
          //glTexCoord3f(s,t,r); /* user-supplied direction vector for cube map texturing */
          glTexCoord3dv(&((masses+mid1)->nx));
          //glVertex3f(x,y,z);
          glVertex3dv(masses+mid1);
          
          glNormal3dv(&((masses+mid2)->nx));
          //glTexCoord2f(world.bcube.vm[otexto+2][0], 
          //  world.bcube.vm[otexto+2][1]);
          //glVertex3dv(masses+mid2);
          //glTexCoord3f(s,t,r); /* user-supplied direction vector for cube map texturing */
          glTexCoord3dv(&((masses+mid2)->nx));
          //glVertex3f(x,y,z);
          glVertex3dv(masses+mid2);
          
          p++;
          
        } // END for num polys
        glEnd();
        // Disable CubeMap
        glMatrixMode(GL_TEXTURE);
        glPopMatrix();
        glMatrixMode(GL_MODELVIEW);
        glDisable(GL_TEXTURE_CUBE_MAP_EXT);
        glDisable(GL_TEXTURE_GEN_S);
        glDisable(GL_TEXTURE_GEN_T);
        glDisable(GL_TEXTURE_GEN_R);
        glDisable(GL_TEXTURE_GEN_Q);
      } 
      else if (smooth) {
        // Smooth shading
        glBegin(GL_TRIANGLES);
        for (i=0; i<(obj->num_polys); i++) {
          mid0 = p->mid0;
          mid1 = p->mid1;
          mid2 = p->mid2;
          matid = p->matid;
          if (omatid != matid) {
            omatid = matid;
            glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, &(world.mats[matid].amb_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, &(world.mats[matid].dif_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, &(world.mats[matid].spe_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, &(world.mats[matid].emi_R));
            glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, world.mats[matid].shi);
          }
          glNormal3dv(&((masses+mid0)->nx));
          glVertex3dv(masses+mid0);
          glNormal3dv(&((masses+mid1)->nx));
          glVertex3dv(masses+mid1);
          glNormal3dv(&((masses+mid2)->nx));
          glVertex3dv(masses+mid2);
          p++;
        }
        glEnd();
      }
      else {
        // Flat shading
        glBegin(GL_TRIANGLES);
        for (i=0; i<(obj->num_polys); i++) {
          mid0 = p->mid0;
          mid1 = p->mid1;
          mid2 = p->mid2;
          matid = p->matid;
          if (omatid != matid) {
            omatid = matid;
            glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, &(world.mats[matid].amb_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, &(world.mats[matid].dif_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, &(world.mats[matid].spe_R));
            glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, &(world.mats[matid].emi_R));
            glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, world.mats[matid].shi);
          }
          glNormal3dv(&(p->nx));
          glVertex3dv(masses + mid0);
          glVertex3dv(masses + mid1);
          glVertex3dv(masses + mid2);
          p++;
        }
        
        glEnd();
        
      }
      
      if( flags & S_TEXTURED ) glDisable( GL_TEXTURE_2D );
      //printf("End of draw conn\n");
}


//------------------ SIM: simDrawForces ------------------
// Draw all forces

void simDrawForces(int obj)
{
  Obj *fobj;
  int fi;
  force *f;
  mass *mf;
  float r;
  long busyforces;
  
  busyforces = world.busyforces;
  fobj = &(world.obj[world.forces_obj_id]);
  f = world.forces;
  for (fi=0; fi < MAXFORCES; f++, fi++) {
    //printf("  simDrawForces(): Force=%d\n", fi);
    if (!(busyforces & (1<<fi))) continue;
    mf = (fobj->masses) + (f->mid0);
    if (mf == NULL) continue;
    //printf("  fpos=[%f, %f, %f]\n", mf->x, mf->y, mf->z);
    if (f->strength > 0) glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_forcem);
    else glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_forcep);
    glPointSize(10);
    glBegin(GL_POINTS);
    glVertex3dv(&(mf->x));
    glEnd();
  }
  //printf("End of draw conn\n");
  
}


//------------------ SIM: simClearAccel ------------------
// Clear all accelerations for all masses of specified object

void simClearAccel(int oid)
{
  Obj *obj;
  mass *m;
  int n;
  
  obj = &(world.obj[oid]);
  m = obj->masses;
  if (m == NULL) return;
  
  for (n=0; n < obj->num_masses; n++) {
    if (!(m->status & S_NOCLRACC)) {
      m->ax = 0;
      m->ay = 0;
      m->az = 0;
    }
    else {
      m->status ^= S_NOCLRACC;
    }
    m++;
  }
}

//------------------ SIM: simApplyForces ------------------
// Apply all forces to masses and update accelerations of object masses


void simApplyForces(oid)
{
  Obj *obj;
  Obj *fobj;
  force *f;
  int mid;
  mass *m;
  mass *mf;
  int fi, mi;
  DWORD fflu;
  double fx, fy, fz;
  double ox, oy, oz;
  double dx, dy, dz;
  double dist, dist2;
  double orad, frad;
  double fattr;
  double dsuf;
  long busyforces;
  
  obj = &(world.obj[oid]);
  fobj = &(world.obj[world.forces_obj_id]);
  busyforces = world.busyforces;
  
  for (fi=0; fi<MAXFORCES; fi++) {
    if (!(busyforces & (1<<fi))) continue;
    //printf("  simApplyForces(): Force=%d\n", fi);
    f = &(world.forces[fi]);
    fflu = f->flu;
    mid = f->mid0;
    mf = (fobj->masses) + mid;
    m = obj->masses;
    for (mi=0; mi<(obj->num_masses); mi++) {
      //if (debug >= 2) printf("  M%d: status=0x%x\n", mi, m->status);
      if (!(m->status & S_FIXED)) {
        if (fflu & m->flu) {  // Check if mass is influenced
          if (mid == -1) {   // No force mass (vector field)
            m->ax += f->fx;
            m->ay += f->fy;
            m->az += f->fz;
          }
          else {              // Force mass present
            fx = mf->x;
            fy = mf->y;
            fz = mf->z;
            ox = m->x;
            oy = m->y;
            oz = m->z;
            orad = m->radius;
            frad = mf->radius;
            dx = fx - ox;
            dy = fy - oy;
            dz = fz - oz;
            dist2 = dx*dx + dy*dy + dz*dz;
            dist = sqrt(dist2);
            //printf("    M%d: orad+frad=%f  dist=%f\n", mi, orad+frad, dist);
            if (dist < frad) {  // See if under influence sphere
              fattr = m->mass * mf->mass / (1+dist2);
              //printf("   fattr=%f\n", fattr);
              dsuf = f->strength * fattr;
              m->ax -= dx*dsuf;
              m->ay -= dy*dsuf;
              m->az -= dz*dsuf;
            }
          }
          //printf("    M%d, acc=[%f,%f,%f]\n", mi, m->ax, m->ay, m->az);
        }
      }
      m++;
    }
    f++;
  }
}


//------------------ SIM: simApplySprings ------------------
// Apply all spring forces to masses and update accelerations

void simApplySprings(int oid)
{
  Obj *obj;
  spring *s;
  mass *masses;
  mass *m1;
  mass *m2;
  int si;
  unsigned int num_springs;
  double dx, dy, dz, force, forcex, forcey, forcez, mag, damp;
  double adjust = 1000.0;

  
  obj = &(world.obj[oid]);
  s = obj->springs;
  masses = obj->masses;
  num_springs = obj->num_springs;


  for (si=0; si<num_springs; si++) {
    //printf("  Spring %d:\n", si);
    m1 = masses + (s->mid0);
    m2 = masses + (s->mid1);

/* old lame C core code

    dx = m1->x - m2->x;
    dy = m1->y - m2->y;
    dz = m1->z - m2->z;

    if (dx || dy || dz) {
      mag = sqrt(dx*dx + dy*dy + dz*dz);
      //printf("    length = %f = [%f,%f,%f]\n", mag, dx, dy, dz);
      force = s->ks * (s->restlen - mag);
      //printf("    force = %f\n", force);
      if (s->kd) {
        damp = ((m1->vx - m2->vx)*dx +
                (m1->vy - m2->vy)*dy +
                (m1->vz - m2->vz)*dz
               ) / mag;
        force -= s->kd * damp;
      }
      force /= mag*adjust;
      forcex = force*dx;
      forcey = force*dy;
      forcez = force*dz;
      if (!(m1->status & S_FIXED)) {
        m1->ax += forcex / m1->mass;
        m1->ay += forcey / m1->mass;
        m1->az += forcez / m1->mass;
      }
      if (!(m2->status & S_FIXED)) {
        m2->ax -= forcex / m2->mass;
        m2->ay -= forcey / m2->mass;
        m2->az -= forcez / m2->mass;
      }
    }
*/
    _asm {
      mov edi, m1;    // *m1
      fld [edi]m1.x;  // m1->x
      mov esi, m2;    // *m2
      fld [esi]m2.x   // m2->x m1->x
      fsub;           // dx
      fld [edi]m1.y;  // m1->y dx
      fld [esi]m2.y   // m2->y m1->y dx
      fsub;           // dy dx
      fld [edi]m1.z;  // m1->z dy dx
      fld [esi]m2.z   // m2->z m1->y dy dx
      fsub;           // dz dy dx
      fld st(2);      // dx dz dy dx
      fmul st,st(3);  // dx*dx dz dy dx
      fld st(2);      // dy dx*dx dz dy dx
      fmul st,st(3);  // dy*dy dx*dx dz dy dx
      fld st(2);      // dz dy*dy dx*dx dz dy dx
      fmul st,st(3);  // dz*dz dy*dy dx*dx dz dy dx
      fadd;           // dz*dz+dy*dy dx*dx dz dy dx
      fadd;           // dz*dz+dy*dy+dx*dx dz dy dx
      fsqrt;          // mag dz dy dx
      mov ebx, s;     // *s
      fld [ebx]s.restlen; // restlen mag dz dy dx
      fld st(1);      // mag restlen mag dz dy dx
      fsub;           // restlen-mag mag dz dy dx
      fld [ebx]s.ks;  // ks restlen-mag mag dz dy dx
      fmul;           // force mag dz dy dx
      // Calc damp, assume s->kd != 0
      fld [edi]m1.vx; // m1->vx force mag dz dy dx
      fld [esi]m2.vx; // m2->vx m1->vx force mag dz dy dx
      fsub;           // (m1->vx - m2->vx) force mag dz dy dx
      fmul st,st(5);  // (m1->vx - m2->vx)*dx force mag dz dy dx
      fld [edi]m1.vy; // m1->vy (m1->vx - m2->vx)*dx force mag dz dy dx
      fld [esi]m2.vy; // m2->vy m1->vy (m1->vx - m2->vx)*dx force mag dz dy dx
      fsub;           // (m1->vy - m2->vy) (m1->vx - m2->vx)*dx force mag dz dy dx
      fmul st,st(5);  // (m1->vy - m2->vy)*dy (m1->vx - m2->vx)*dx force mag dz dy dx
      fadd;           // (m1->vy - m2->vy)*dy+(m1->vx - m2->vx)*dx force mag dz dy dx
      fld [edi]m1.vz; // m1->vz (m1->vy - m2->vy)*dy+(m1->vx - m2->vx)*dx force mag dz dy dx
      fld [esi]m2.vz; // m2->vz m1->vz (m1->vy - m2->vy)*dy+(m1->vx - m2->vx)*dx force mag dz dy dx
      fsub;           // (m1->vz - m2->vz) (m1->vy - m2->vy)*dy+(m1->vx - m2->vx)*dx force mag dz dy dx
      fmul st,st(4);  // (m1->vz - m2->vz)*dz (m1->vy - m2->vy)*dy+(m1->vx - m2->vx)*dx force mag dz dy dx
      fadd;           // (m1->vz - m2->vz)*dz+(m1->vy - m2->vy)*dy+(m1->vx - m2->vx)*dx force mag dz dy dx
      fdiv st,st(2);  // damp force mag dz dy dx
      fld [ebx]s.kd;  // s->kd damp force mag dz dy dx
      fmul;           // s->kd*damp force mag dz dy dx
      fsub;           // force=force-(s->kd*damp) mag dz dy dx
      // End of damp calc
      fxch st(1);     // mag force dz dy dx
      fmul adjust;    // mag*adjust force dz dy dx
      fdiv;           // force=force/mag*adjust dz dy dx
      fmul st(3), st; // force dz dy forcex
      fmul st(2), st; // force dz forcey forcex
      fmulp st(1), st; // forcez forcey forcex
      mov eax, S_FIXED; // Cache S_FIXED
      test eax, [edi]m1.status; // Test m1->S_FIXED
      jne m1fixed;
      fld [edi]m1.mass; // m1->mass forcez forcey forcex
      fld st;         // m1->mass m1->mass forcez forcey forcex
      fdivr st, st(4); // forcex/m1->mass m1->mass forcez forcey forcex
      fld [edi]m1.ax; // m1->ax forcex/m1->mass m1->mass forcez forcey forcex
      fadd;           // m1->ax+forcex/m1->mass m1->mass forcez forcey forcex
      fstp [edi]m1.ax; // m1->mass forcez forcey forcex
      fld st;         // m1->mass m1->mass forcez forcey forcex
      fdivr st, st(3); // forcey/m1->mass m1->mass forcez forcey forcex
      fld [edi]m1.ay; // m1->ay forcey/m1->mass m1->mass forcez forcey forcex
      fadd;           // m1->ay+forcey/m1->mass m1->mass forcez forcey forcex
      fstp [edi]m1.ay; // m1->mass forcez forcey forcex
      fdivr st, st(1); // forcez/m1->mass forcez forcey forcex
      fld [edi]m1.az; // m1->az forcez/m1->mass forcez forcey forcex
      fadd;           // m1->az+forcez/m1->mass forcez forcey forcex
      fstp [edi]m1.az; // forcez forcey forcex
    m1fixed:
      test eax, [esi]m2.status; // Test m1->S_FIXED
      jne m2fixed;
      fld [esi]m2.mass; // m2->mass forcez forcey forcex
      fld st;         // m2->mass m1->mass forcez forcey forcex
      fdivr st, st(4); // forcex/m2->mass m1->mass forcez forcey forcex
      fld [esi]m2.ax; // m2->ax forcex/m2->mass m2->mass forcez forcey forcex
      fsubr;           // m2->ax-forcex/m2->mass m2->mass forcez forcey forcex
      fstp [esi]m2.ax; // m2->mass forcez forcey forcex
      fld st;         // m2->mass m2->mass forcez forcey forcex
      fdivr st, st(3); // forcey/m2->mass m2->mass forcez forcey forcex
      fld [esi]m2.ay; // m2->ay forcey/m2->mass m2->mass forcez forcey forcex
      fsubr;           // m2->ay-forcey/m2->mass m2->mass forcez forcey forcex
      fstp [esi]m2.ay; // m2->mass forcez forcey forcex
      fdivr st, st(1); // forcez/m2->mass forcez forcey forcex
      fld [esi]m2.az; // m2->az forcez/m2->mass forcez forcey forcex
      fsubr;           // m2->az-forcez/m2->mass forcez forcey forcex
      fstp [esi]m2.az; // forcez forcey forcex
    m2fixed:
      fstp st;
      fstp st;
      fstp st;
    }

    s++;
  }


}


//------------------ SIM: simFindVel ------------------
// Apply accelerations and find velocities of object masses

void simFindVel(int oid)
{
  Obj *obj;
  mass *m;
  int n;
  
  obj = &(world.obj[oid]);
  m = obj->masses;
  if (m == NULL) return;
  
  for (n=0; n < (obj->num_masses); n++) {
    m->vx += m->ax;
    m->vy += m->ay;
    m->vz += m->az;
    m++;
  }
}


//------------------ SIM: simFindPos ------------------
// Apply velocities and find position of object masses

void simFindPos(int oid)
{
  Obj *obj;
  Obj *bc_obj;
  mass *m;
  mass *bc_m, *bc_m_p;
  poly *bc_p;
  double x, y, z;
  double vx, vy, vz;
  double vnx, vny, vnz;
  double vtx, vty, vtz;
  double px, py, pz;
  double nx, ny, nz;
  int n, i;
  double dotp;
  double dist;
  int collided;
  
  obj = &(world.obj[oid]);
  m = obj->masses;
  if (m == NULL) return;
  
  for (n=0; n < (obj->num_masses); n++) {
    m->x += m->vx;
    m->y += m->vy;
    m->z += m->vz;
    // Check if bumping on ground
    if (m->status & S_BUMPGND) {
      if (m->y < 0) {
        m->y = -(m->y);
        m->vy = -(m->vy);
      }
    }
    // Check for BCube
    if (m->status & S_BUMPBC) {
      // Cache mass xyz pos
      x = m->x;
      y = m->y;
      z = m->z;
      // Cache mass xyz vel
      vx = m->vx;
      vy = m->vy;
      vz = m->vz;
      bc_obj = &(world.obj[world.bcube_obj_id]);
      bc_p = bc_obj->polys;
      bc_m = bc_obj->masses;
      collided = 0;
      for (i=0; i<12; i+=2, bc_p+=2) {
        bc_m_p = bc_m + (bc_p->mid0);
        nx = bc_p->nx;
        ny = bc_p->ny;
        nz = bc_p->nz;
        // a plane point (compensate for zbuf error)
        px = bc_m_p->x -nx*0.01;
        py = bc_m_p->y -ny*0.01;
        pz = bc_m_p->z -nz*0.01;
        vnx = (m->x - px) * nx;
        vny = (m->y - py) * ny;
        vnz = (m->z - pz) * nz;
        dotp = vnx + vny + vnz;
        //printf("(%d) face%d dotp=%f\n", simtime, i>>1, dotp);
        if (dotp > 0) {
          // Rollback position
          //m->x -= (m->vx);
          //m->y -= (m->vy);
          //m->z -= (m->vz);
          // Particle has collided
          collided = 1;
          //printf("(oid=%d time=%d) mass%d outof bcface%d\n", oid, simtime, n, i>>1);
          // dotp = N.a
          vx = (m->ax) * nx;
          vy = (m->ay) * ny;
          vz = (m->az) * nz;
          dotp = vx + vy + vz; // Now dotp > 0 if mass is pushed out of surface.
          if (1/*dotp > 0*/) {
            //printf("  PushedA!\n");
            //m->ax = -vx;
            //m->ay = -vy;
            //m->az = -vz;
            //m->status |= S_NOCLRACC;
            
            // Rollback to BCube surface
            // Find distance from plane
            dist = fabs(nx*x + ny*y + nz*z - (nx*px + ny*py + nz*pz));
            //printf("dist=%f\n", dist);
            //dist += 0.01;  // Patch distance to compensate ZBuffer errors
            m->x -= dist*nx;
            m->y -= dist*ny;
            m->z -= dist*nz;
            
            // dotp = N.v
            vnx = vx * nx;
            vny = vy * ny;
            vnz = vz * nz;
            dotp = vnx + vny + vnz;
            // Check if mass gets sticked
            if (dotp < -0.02) {
              //m->status |= S_STICKED;
              //m->vx = 0;
              //m->vy = 0;
              //m->vz = 0;
            }
            // vnx = normal velocity
            vnx = -dotp * vx;
            vny = -dotp * vy;
            vnz = -dotp * vz;
            // vtx = tangential velocity
            vtx = vx - vnx;
            vty = vy - vny;
            vtz = vz - vnz;
            // Find new normal and tangential velocity
            m->vx = cfrict*vtx + crest*vnx;
            m->vy = cfrict*vty + crest*vny;
            m->vz = cfrict*vtz + crest*vnz;
            //printf("  x=%f\t y=%f\t z=%f\n", vtx, vty, vtz);
          }
        } // End if (collided)
        else {
          // Handle sticked masses (BUGGY)
          if (m->status & S_STICKED) {
            // Check if mass gets unsticked !
            vnx = vx * nx;
            vny = vy * ny;
            vnz = vz * nz;
            dotp = vnx + vny + vnz;
            if (dotp > -0.002) {
              printf("dotp=%f\n", dotp);
              m->status ^= S_STICKED;
            }
            else {
              dist = fabs(nx*x + ny*y + nz*z - (nx*px + ny*py + nz*pz));
              //m->x -= dist*nx;
              //m->y -= dist*ny;
              //m->z -= dist*nz;
              m->vx = 0;
              m->vy = 0;
              m->vz = 0;
            }
          }
        }
      } // End for (faces)
    }
    // Inc mass ptr
    m++;
  }
}


//------------------ SIM: simSetBCube ------------------
// Set Bounding Cube
// Return: oid on success
//          -1 on error
int simSetBCube(float cx, float cy, float cz, float l, int mode, int matid)
{
  Obj *obj;
  mass *masses;
  int oid;
  
  if (world.bcube_obj_id != -1) {
    printf("  *** ERROR *** simSetBCube(): Bounding cube already set (oid=%d).\n", world.bcube_obj_id);
    return -1;
  }
  
  oid = simAddCubeObj(cx,cy,cz, l, 0,0, mode | S_FIXED | S_ALIVE | S_CULLBACK | S_CW | S_TEXTURED, 0, 0);
  if (oid == -1) return -1;
  obj = &(world.obj[oid]);
  
  world.bcube_obj_id = oid;
  sprintf(obj->name, "BoundingCube");
  if (debug) printf("  simSetBCube(): Setting Bounding Cube (oid=%d).\n", oid);
  
  // Reset bcube rotation
  world.bcube.rx = 0.0;
  world.bcube.ry = 0.0;
  world.bcube.rz = 0.0;
  
  masses = obj->masses;
  for (i=0; i<8; i++) {
    world.bcube.vo[i][0] = (masses+i)->x - cx;
    world.bcube.vo[i][1] = (masses+i)->y - cy;
    world.bcube.vo[i][2] = (masses+i)->z - cz;
  }
  world.bcube.cx = cx;
  world.bcube.cy = cy;
  world.bcube.cz = cz;
  
}


//------------------ SIM: simTraslObj ------------------
// Translate object
void simTraslObj(int oid, double tx, double ty, double tz)
{
  Obj *obj;
  mass *masses;
  
  obj = &(world.obj[oid]);
  masses = obj->masses;
  
  for (i=0; i<obj->num_masses; i++) {
    masses->x += tx;
    masses->y += ty;
    masses->z += tz;
    masses++;
  }
}


//------------------ SIM: simTraslBCube ------------------
// Translate Bounding Cube
void simTraslBCube(double tx, double ty, double tz)
{
  world.bcube.cx += tx;
  world.bcube.cy += ty;
  world.bcube.cz += tz;
}

//------------------ SIM: simRotObj ------------------
// Rotate Bounding Cube
void simRotObj(int oid, double rx, double ry, double rz)
{
  Obj *obj;
  mass *masses;
  double *vop;
  double x, y, z;
  double nx, ny, nz;
  double sinrx, sinry, sinrz;
  double cosrx, cosry, cosrz;
  
  sinrx = sin(rx);
  sinry = sin(ry);
  sinrz = sin(rz);
  cosrx = cos(rx);
  cosry = cos(ry);
  cosrz = cos(rz);
  
  obj = &(world.obj[oid]);
  masses = obj->masses;
  
  for (i=0; i<obj->num_masses; i++) {
    x = masses[i].x;
    y = masses[i].y;
    z = masses[i].z;
    // rx
    nx = x;
    ny = - y*cosrx + z*sinrx;
    nz = - y*sinrx - z*cosrx;
    // ry
    x = nx*cosry + nz*sinry;
    y = ny;
    z = -nx*sinry + nz*cosry;
    // rz
    nx = x*cosrz - y*sinrz;
    ny = x*sinrz + y*cosrz;
    nz = z;
    masses[i].x = nx;
    masses[i].y = ny;
    masses[i].z = nz;
  }
  // Recalculate all normals for BCube
  simFindSNorm(oid);
  simFindVNorm(oid);
}

//------------------ SIM: simRotBCube ------------------
// Rotate Bounding Cube
void simRotBCube(double rx, double ry, double rz)
{
  Obj *obj;
  mass *masses;
  double *vop;
  double x, y, z;
  double nx, ny, nz;
  double sinrx, sinry, sinrz;
  double cosrx, cosry, cosrz;
  
  sinrx = sin(rx);
  sinry = sin(ry);
  sinrz = sin(rz);
  cosrx = cos(rx);
  cosry = cos(ry);
  cosrz = cos(rz);
  
  obj = &(world.obj[world.bcube_obj_id]);
  masses = obj->masses;
  
  for (i=0; i<8; i++) {
    vop = &(world.bcube.vo[i][0]);
    x = *(vop);
    y = *(vop+1);
    z = *(vop+2);
    // rx
    nx = x;
    ny = - y*cosrx + z*sinrx;
    nz = - y*sinrx - z*cosrx;
    // ry
    x = nx*cosry + nz*sinry;
    y = ny;
    z = -nx*sinry + nz*cosry;
    // rz
    nx = x*cosrz - y*sinrz;
    ny = x*sinrz + y*cosrz;
    nz = z;
    (masses+i)->x = world.bcube.cx + nx;
    (masses+i)->y = world.bcube.cy + ny;
    (masses+i)->z = world.bcube.cz + nz;
  }
  // Recalculate all normals for BCube
  simFindSNorm(world.bcube_obj_id);
  simFindVNorm(world.bcube_obj_id);
}


//------------------ SIM: simAddSheetObj ------------------
// Add a sheet object
// Return: oid on success
//          -1 on error
int simAddSheetObj(float cx, float cy, float cz, float l, int nsq1, int nsq2, double ks, double kd, int mode, DWORD f_mask, int matid)
{
  double hl = l/2;
  double ls2 = sqrt(2)*l;
  double x0, y0, z0;
  int maxnsq;
  mass *m;
  Obj *obj;
  int oid;
  int sid;
  int mid;
  int status;
  int conns[2];
  double n0[3];
  double n1[3];
  int i, j;
  
  oid = simAddObject("SheetObj", mode);
  if (oid == -1) return -1;
  
  maxnsq = (nsq1 > nsq2) ? nsq1 : nsq2;
  x0 = cx - l*nsq1/2;
  y0 = cy;
  z0 = cz - l*nsq2/2;
  
  // Gen masses
  status = mode | S_ALIVE;
  for (i=0; i<=nsq1; i++) {
    for (j=0; j<=nsq2; j++) {
      mid = simAddMass(oid, &m);
      if (mid == -1) return -1;
      m->x = x0 + l*i;
      m->y = y0;
      m->z = z0 + l*j;
      m->flu = f_mask;
      m->status = status;
    }
  }
  
  // Gen conns
  if (mode & M_GENCONNS) {
    for (j=0; j<=nsq1; j++) {
      for (i=0; i<nsq2; i++) {
        conns[0] = j*(nsq2+1) + i;
        conns[1] = j*(nsq2+1) + i+1;
        simAddConn(oid, conns, 2);
      }
    }
    for (j=0; j<=nsq2; j++) {
      for (i=0; i<nsq1; i++) {
        conns[0] = j+(i+1)*(nsq2+1);
        conns[1] = j+i*(nsq2+1);
        simAddConn(oid, conns, 2);
      }
    }
  }
  
  // Gen springs
  if (mode & M_GENSPRINGS) {
    // Squares springs ver
    for (j=0; j<=nsq1; j++) {
      for (i=0; i<nsq2; i++) {
        sid = simAddSpring(oid, j*(nsq2+1)+i, j*(nsq2+1)+i+1, l, ks, kd, S_ALIVE);
      }
    }
    // Squares springs hor
    for (j=0; j<=nsq2; j++) {
      for (i=0; i<nsq1; i++) {
        sid = simAddSpring(oid, j+(i+1)*(nsq2+1), j+i*(nsq2+1), l, ks, kd, S_ALIVE);
      }
    }
    // Squares springs diag
    for (j=0; j<nsq2; j++) {
      for (i=0; i<nsq1; i++) {
        sid = simAddSpring(oid, j+i*(nsq2+1), j+1+(i+1)*(nsq2+1), ls2, ks, kd, S_ALIVE);
        sid = simAddSpring(oid, j+1+i*(nsq2+1), j+(i+1)*(nsq2+1), ls2, ks, kd, S_ALIVE);
      }
    }
    // Full len springs ver
    for (j=0; j<=nsq1; j++) {
      sid = simAddSpring(oid, j*(nsq2+1), j*(nsq2+1)+nsq2, l*nsq2, ks, kd, S_ALIVE);
    }
    // Full len springs hor
    for (j=0; j<=nsq2; j++) {
      sid = simAddSpring(oid, j, j+(nsq2+1)*nsq1, l*nsq1, ks, kd, S_ALIVE);
    }
    
  }
  
  // Gen polys
  if (mode & M_GENPOLYS) {
    status = mode | S_ALIVE;
    for (j=0; j<nsq2; j++) {
      for (i=0; i<nsq1; i++) {
        simAddPoly(oid, j+1+(i+1)*(nsq2+1), j+1+i*(nsq2+1), j+i*(nsq2+1), NULL, NULL, NULL, status, NULL, matid);
        simAddPoly(oid, j+i*(nsq2+1), j+(i+1)*(nsq2+1), j+1+(i+1)*(nsq2+1), NULL, NULL, NULL, status, NULL, matid);
      }
    }
  }
  
  
}

//------------------ SIM: simAddCubeObj ------------------
// Add a cube object
// Return: oid on success
//          -1 on error

int simAddCubeObj(float cx, float cy, float cz, float l, double ks, double kd, int mode, DWORD f_mask, int matid)
{
  double hl = l/2;
  double ls2 = sqrt(2)*l;
  mass *m;
  Obj *obj;
  int oid;
  int sid;
  int mid[8];
  int conns[4];
  int status;
  double n0[3];
  double n1[3];
  
  oid = simAddObject("CubeObj", mode);
  if (oid == -1) return -1;
  
  status = mode | S_ALIVE;
  
  mid[0] = simAddMass(oid, &m);
  if (mid[0] == -1) return -1;
  m->x = cx - hl;
  m->y = cy - hl;
  m->z = cz + hl;
  m->flu = f_mask;
  m->status = status;
  mid[1] = simAddMass(oid, &m);
  if (mid[1] == -1) return -1;
  m->x = cx + hl;
  m->y = cy - hl;
  m->z = cz + hl;
  m->flu = f_mask;
  m->status = status;
  mid[2] = simAddMass(oid, &m);
  if (mid[2] == -1) return -1;
  m->x = cx + hl;
  m->y = cy - hl;
  m->z = cz - hl;
  m->flu = f_mask;
  m->status = status;
  mid[3] = simAddMass(oid, &m);
  if (mid[3] == -1) return -1;
  m->x = cx - hl;
  m->y = cy - hl;
  m->z = cz - hl;
  m->flu = f_mask;
  m->status = status;
  mid[4] = simAddMass(oid, &m);
  if (mid[4] == -1) return -1;
  m->x = cx - hl;
  m->y = cy + hl;
  m->z = cz + hl;
  m->flu = f_mask;
  m->status = status;
  mid[5] = simAddMass(oid, &m);
  if (mid[5] == -1) return -1;
  m->x = cx + hl;
  m->y = cy + hl;
  m->z = cz + hl;
  m->flu = f_mask;
  m->status = status;
  mid[6] = simAddMass(oid, &m);
  if (mid[6] == -1) return -1;
  m->x = cx + hl;
  m->y = cy + hl;
  m->z = cz - hl;
  m->flu = f_mask;
  m->status = status;
  mid[7] = simAddMass(oid, &m);
  if (mid[7] == -1) return -1;
  m->x = cx - hl;
  m->y = cy + hl;
  m->z = cz - hl;
  m->flu = f_mask;
  m->status = status;
  
  if (mode & M_GENCONNS) {
    conns[0] = mid[0];
    conns[1] = mid[1];
    conns[2] = mid[3];
    conns[3] = mid[4];
    simAddConn(oid, conns, 4);
    conns[0] = mid[2];
    conns[1] = mid[1];
    conns[2] = mid[3];
    conns[3] = mid[6];
    simAddConn(oid, conns, 4);
    conns[0] = mid[5];
    conns[1] = mid[1];
    conns[2] = mid[4];
    conns[3] = mid[6];
    simAddConn(oid, conns, 4);
    conns[0] = mid[7];
    conns[1] = mid[4];
    conns[2] = mid[3];
    conns[3] = mid[6];
    simAddConn(oid, conns, 4);
  }
  
  if (mode & M_GENPOLYS) {
    status = S_ALIVE;
    n0[0]=0; n0[1]=-1, n0[2]=0;
    simAddPoly(oid, mid[2], mid[1], mid[0], n0, NULL, NULL, status, NULL, matid);
    simAddPoly(oid, mid[0], mid[3], mid[2], n0, NULL, NULL, status, NULL, matid);
    n0[0]=0; n0[1]=0, n0[2]=1;
    simAddPoly(oid, mid[4], mid[0], mid[1], n0, NULL, NULL, status, NULL, matid);
    simAddPoly(oid, mid[1], mid[5], mid[4], n0, NULL, NULL, status, NULL, matid);
    n0[0]=1; n0[1]=0, n0[2]=0;
    simAddPoly(oid, mid[5], mid[1], mid[2], n0, NULL, NULL, status, NULL, matid);
    simAddPoly(oid, mid[2], mid[6], mid[5], n0, NULL, NULL, status, NULL, matid);
    n0[0]=0; n0[1]=-1, n0[2]=0;
    simAddPoly(oid, mid[5], mid[6], mid[7], n0, NULL, NULL, status, NULL, matid);
    simAddPoly(oid, mid[7], mid[4], mid[5], n0, NULL, NULL, status, NULL, matid);
    n0[0]=-1; n0[1]=0, n0[2]=0;
    simAddPoly(oid, mid[3], mid[0], mid[4], n0, NULL, NULL, status, NULL, matid);
    simAddPoly(oid, mid[4], mid[7], mid[3], n0, NULL, NULL, status, NULL, matid);
    n0[0]=0; n0[1]=0, n0[2]=-1;
    simAddPoly(oid, mid[2], mid[3], mid[7], n0, NULL, NULL, status, NULL, matid);
    simAddPoly(oid, mid[7], mid[6], mid[2], n0, NULL, NULL, status, NULL, matid);
  }
  
  
  if (mode & M_GENSPRINGS) {
    sid = simAddSpring(oid, mid[0], mid[1], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[1], mid[5], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[5], mid[4], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[4], mid[0], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[3], mid[2], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[2], mid[6], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[6], mid[7], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[3], mid[7], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[3], mid[0], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[4], mid[7], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[6], mid[5], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[1], mid[2], l, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    
    sid = simAddSpring(oid, mid[0], mid[2], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[1], mid[3], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[1], mid[4], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[0], mid[5], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[3], mid[4], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[0], mid[7], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[5], mid[7], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[4], mid[6], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[3], mid[6], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[2], mid[7], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[2], mid[5], ls2, ks, kd, S_ALIVE);
    if (sid == -1) return -1;
    sid = simAddSpring(oid, mid[1], mid[6], ls2, ks, kd, S_ALIVE);
  }
  
  return oid;  
}


//------------------ SIM: simAddFForce ------------------
// Add a force (field)
// Return: fid (force influence id) if success.
//         0 if error.

long simAddFForce(double fx, double fy, double fz, int mstatus) {
  long fid;
  force *fr;
  int i;
  int found;
  long b;
  
  for (i=0, b=0x1; i<MAXFORCES; i++, b=b<<1) {
    if (!(world.busyforces & b)) {
      fid = b;
      found = TRUE;
      break;
    }
  }
  if (found == FALSE) {
    printf("  *** ERROR *** simAddFForce(): MAX NUMBER OF FORCES (%d) REACHED.\n", MAXFORCES);
    return 0;
  }
  
  fr = &(world.forces[i]);
  
  fr->fx = fx;
  fr->fy = fy;
  fr->fz = fz;
  fr->strength = 1;
  fr->mid0 = -1;   // No mass (it's a vector field)
  fr->status = 0;
  fr->flu = b;
  world.busyforces |= b;
  if (debug >= 2) printf("  simAddFForce():  fid=$%x\n", fid);
  return fid;
}


//------------------ SIM: simAddPForce ------------------
// Add a punctual force
// Return: fid (force influence id) if success.
//         0 if error.

long simAddPForce(double cx, double cy, double cz, double mradius, int mstatus, double fstrength)
{
  mass *cur_mp;
  force *cur_fp;
  Obj *obj;
  long fid;
  int oid;
  int mid;
  int found = FALSE;
  int i;
  long b;
  
  for (i=0, b=0x1; i<MAXFORCES; i++, b=b<<1) {
    if (!(world.busyforces & b)) {
      fid = b;
      found = TRUE;
      break;
    }
  }
  if (found == FALSE) {
    printf("  *** ERROR *** simAddPForce(): MAX NUMBER OF FORCES (%d) REACHED.\n", MAXFORCES);
    return 0;
  }
  
  oid = world.forces_obj_id;
  mid = simAddMass(oid, &cur_mp);
  if (mid == -1) return 0;
  obj = &(world.obj[oid]);
  //cur_mp = (obj->masses) + mid;
  
  cur_mp->status = mstatus;
  cur_mp->x = cx;
  cur_mp->y = cy;
  cur_mp->z = cz;
  cur_mp->radius = mradius;
  cur_fp = &(world.forces[i]);
  cur_fp->strength = fstrength;
  cur_fp->mid0 = mid;
  cur_fp->flu = b;
  world.busyforces |= b;
  if (debug >= 2) printf("  simAddPForce():  fid=$%x\n", fid);
  return(fid);
}

//------------------ SIM: simInitWorld ------------------
// Initialize world (free old world structures and init new ones).
// Return: 1 on success.
//         0 on error.

int simInitWorld(char *name)
{
  Obj *obj;
  int fobjid;
  int matid;
  int i;
  float amb[4] = {0.3, 0.3, 0.3, 1.0};
  float dif[4] = {1.0, 1.0, 1.0, 1.0};
  float spe[4] = {0.2, 0.0, 0.0, 1.0};
  float emi[4] = {0.0, 0.0, 0.0, 1.0};
  float shi = 128.0;
  
  // FREE OLD STRUCTURES
  
  for (i=0; i<MAXOBJECTS; i++) {
    world.obj[i].id = -1;
  }
  if (name != NULL) strncpy(world.name, name, 255);
  else sprintf(world.name, "Unknown_World");
  // Init world struct
  if (debug >= 2) printf("  simInitWorld(): World name =\"%s\"\n", world.name);
  world.num_obj = 0;
  world.last_obj_id = 0;
  world.busyforces = 0;
  // Create world forces
  fobjid = simAddObject("Forces", S_WORLDFORCES);
  if (fobjid == -1) return 0;
  world.forces_obj_id = fobjid;
  world.bcube_obj_id = -1;
  // Add default material
  matid = simAddMat(amb, dif, spe, emi, shi, S_ALIVE);
  sprintf(world.mats[matid].name, "default");
  return(1);
}


//------------------ SIM: simAddObject ------------------
// Add an object
// Return: oid (object id) >= 0 on success.
//         -1 on error.
int simAddObject(char *name, int flags)
{
  Obj *obj;
  void *ptr;
  int oid;
  int found = FALSE;
  int i;
  
  for (i=0; i<MAXOBJECTS; i++) {
    if (world.obj[i].id == -1) {
      obj = &(world.obj[i]);
      found = TRUE;
      break;
    }
  }
  if (found == FALSE) {
    printf("  *** ERROR *** simAddObject(): MAX NUMBER OF OBJECTS (%d) REACHED.\n", MAXOBJECTS);
    return -1;
  }
  oid = i;
  if (name != NULL) strncpy(obj->name, name, 255);
  else sprintf(obj->name, "NoName");
  if (debug >= 2) printf("  simAddObject(): Object id=%d  name=\"%s\"  flags=$%x\n", oid, obj->name, flags);
  obj->id = oid;
  obj->num_masses = 0;
  obj->num_springs = 0;
  obj->num_conns = 0;
  obj->num_polys = 0;
  obj->num_subobj = 0;
  obj->all_masses = 0;
  obj->all_springs = 0;
  obj->all_conns = 0;
  obj->all_polys = 0;
  obj->all_subobj = 0;
  obj->masses = NULL;
  obj->springs = NULL;
  obj->conns = NULL;
  obj->polys = NULL;
  obj->subobj_id = NULL;
  obj->flags = flags;
  for (i=0; i<16; i++) {  // Set xform matrix to identity
    obj->xmat[i] = 0.0;
  }
  obj->xmat[0] = 1.0;
  obj->xmat[5] = 1.0;
  obj->xmat[10] = 1.0;
  obj->xmat[15] = 1.0;
  if (flags & S_WORLDFORCES) {  // Check if we are creating the world forces object
    if (debug >= 2) printf("  simAddObject(): >>> Setting system forces object (oid=%d) <<<\n", oid);
    ptr = malloc(sizeof(mass)*32);
    if (ptr == NULL) {
      printf("  *** ERROR *** simAddObject(): Failed malloc for system forces masses.\n");
      return -1;
    }
    world.forces_obj_id = oid;
    world.last_obj_id = oid;
    world.num_obj++;
    return(oid);
  }
  
  world.last_obj_id = oid;
  world.num_obj++;
  return(oid);
}

//------------------ SIM: simAddSpring ------------------
// Add a new spring to specified object
// Return: sid on success
//         -1  on error

int simAddSpring(int oid, int mid0, int mid1, double l, double ks, double kd, int status)
{
  Obj *obj;
  int sid;
  mass *m0, *m1;
  mass *masses;
  spring *sr;
  
  obj = &(world.obj[oid]);
  masses = obj->masses;
  
  if ((obj->all_springs - obj->num_springs) <= 0) {
    n = sizeof(spring) * (obj->all_springs + ALL_SPRINGS);
    if (debug > 2) printf("  simAddSpring(): Expanding size of springs structure for obj%d to %d\n", oid, n);
    sr = (spring*)malloc(n);
    if (sr == NULL) {
      printf("  *** ERROR *** simAddSpring(): Failed malloc(%d) for springs (oid=%d).\n", n, oid);
      return -1;
    }
    memcpy(sr, obj->springs, (obj->all_springs)*sizeof(spring));
    free(obj->springs);
    obj->springs = sr;
    obj->all_springs += ALL_SPRINGS;
  }
  
  sid = obj->num_springs;
  obj->num_springs += 1;
  
  sr = obj->springs + sid;
  sr->id = sid;
  sr->ks = ks;
  sr->kd = kd;
  sr->restlen = l;
  sr->mid0 = mid0;
  sr->mid1 = mid1;
  sr->status = status;
  
  return sid;
}


void GenTexts( void )
{
  int			tga_x[6], tga_y[6];
  int			i;
  
  Acc_BindTexture = wglGetProcAddress("glBindTextureEXT");
  if( !Acc_BindTexture )
    Acc_BindTexture = (PROC)glBindTexture;
  
  Acc_GenTextures = wglGetProcAddress("glGenTexturesEXT");
  if( !Acc_GenTextures )
    Acc_GenTextures = (PROC)glGenTextures;
  
  Acc_DeleteTextures = wglGetProcAddress("glDeleteTexturesEXT");
  if( !Acc_DeleteTextures )
    Acc_DeleteTextures = (PROC)glDeleteTextures;
  
  //imagedata[0] = Texture_DecodeTGA( "..\\textures\\0.tga", &tga_x[0], &tga_y[0]);
  //imagedata[1] = Texture_DecodeTGA( "..\\textures\\1.tga", &tga_x[1], &tga_y[1]);
  //imagedata[2] = Texture_DecodeTGA( "..\\textures\\2.tga", &tga_x[2], &tga_y[2]);
  //imagedata[3] = Texture_DecodeTGA( "..\\textures\\3.tga", &tga_x[3], &tga_y[3]);
  //imagedata[4] = Texture_DecodeTGA( "..\\textures\\4.tga", &tga_x[4], &tga_y[4]);
  //imagedata[5] = Texture_DecodeTGA( "..\\textures\\5.tga", &tga_x[5], &tga_y[5]);
  imagedata[2] = Texture_DecodeTGA( "0.tga", &tga_x[0], &tga_y[0], cubemap_[0]);
  imagedata[4] = Texture_DecodeTGA( "1.tga", &tga_x[1], &tga_y[1], cubemap_[1]);
  imagedata[0] = Texture_DecodeTGA( "2.tga", &tga_x[2], &tga_y[2], cubemap_[2]);
  imagedata[3] = Texture_DecodeTGA( "3.tga", &tga_x[3], &tga_y[3], cubemap_[3]);
  imagedata[5] = Texture_DecodeTGA( "4.tga", &tga_x[4], &tga_y[4], cubemap_[4]);
  imagedata[1] = Texture_DecodeTGA( "5.tga", &tga_x[5], &tga_y[5], cubemap_[5]);
  
  printf("Textures load completed.\n");
  
  
  for( i = 0 ; i < 6 ; i++ )
  {
    Acc_GenTextures(1, &world.bcube.txts[i] );
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    Acc_BindTexture(GL_TEXTURE_2D, world.bcube.txts[i]);
    
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
    
    //glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    //glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    
    glTexImage2D(GL_TEXTURE_2D, 0, 4, 
      tga_x[i], tga_y[i], 0,
      GL_RGBA, GL_UNSIGNED_BYTE, imagedata[i]);
    
    gluBuild2DMipmaps( GL_TEXTURE_2D, 4,
      tga_x[i], tga_y[i],
      GL_RGBA, GL_UNSIGNED_BYTE, imagedata[i]);
      
    
  }
  glDisable(GL_TEXTURE_2D);
  
  // Face 0
  world.bcube.vm[ 0][0] = 1;
  world.bcube.vm[ 0][1] = 1;
  world.bcube.vm[ 1][0] = 1;
  world.bcube.vm[ 1][1] = 0;
  world.bcube.vm[ 2][0] = 0;
  world.bcube.vm[ 2][1] = 0;
  world.bcube.vm[ 3][0] = 0;
  world.bcube.vm[ 3][1] = 0;
  world.bcube.vm[ 4][0] = 0;
  world.bcube.vm[ 4][1] = 1;
  world.bcube.vm[ 5][0] = 1;
  world.bcube.vm[ 5][1] = 1;

  // Face 1
  world.bcube.vm[ 6][0] = 1;
  world.bcube.vm[ 6][1] = 1;
  world.bcube.vm[ 7][0] = 1;
  world.bcube.vm[ 7][1] = 0;
  world.bcube.vm[ 8][0] = 0;
  world.bcube.vm[ 8][1] = 0;
  world.bcube.vm[ 9][0] = 0;
  world.bcube.vm[ 9][1] = 0;
  world.bcube.vm[10][0] = 0;
  world.bcube.vm[10][1] = 1;
  world.bcube.vm[11][0] = 1;
  world.bcube.vm[11][1] = 1;

  // Face 2
  world.bcube.vm[12][0] = 1;
  world.bcube.vm[12][1] = 1;
  world.bcube.vm[13][0] = 1;
  world.bcube.vm[13][1] = 0;
  world.bcube.vm[14][0] = 0;
  world.bcube.vm[14][1] = 0;
  world.bcube.vm[15][0] = 0;
  world.bcube.vm[15][1] = 0;
  world.bcube.vm[16][0] = 0;
  world.bcube.vm[16][1] = 1;
  world.bcube.vm[17][0] = 1;
  world.bcube.vm[17][1] = 1;

  // Face 3
  world.bcube.vm[18][0] = 1;
  world.bcube.vm[18][1] = 1;
  world.bcube.vm[19][0] = 1;
  world.bcube.vm[19][1] = 0;
  world.bcube.vm[20][0] = 0;
  world.bcube.vm[20][1] = 0;
  world.bcube.vm[21][0] = 0;
  world.bcube.vm[21][1] = 0;
  world.bcube.vm[22][0] = 0;
  world.bcube.vm[22][1] = 1;
  world.bcube.vm[23][0] = 1;
  world.bcube.vm[23][1] = 1;

  // Face 4
  world.bcube.vm[24][0] = 1;
  world.bcube.vm[24][1] = 0;
  world.bcube.vm[25][0] = 0;
  world.bcube.vm[25][1] = 0;
  world.bcube.vm[26][0] = 0;
  world.bcube.vm[26][1] = 1;
  world.bcube.vm[27][0] = 0;
  world.bcube.vm[27][1] = 1;
  world.bcube.vm[28][0] = 1;
  world.bcube.vm[28][1] = 1;
  world.bcube.vm[29][0] = 1;
  world.bcube.vm[29][1] = 0;

  // Face 5
  world.bcube.vm[30][0] = 1;
  world.bcube.vm[30][1] = 0;
  world.bcube.vm[31][0] = 0;
  world.bcube.vm[31][1] = 0;
  world.bcube.vm[32][0] = 0;
  world.bcube.vm[32][1] = 1;
  world.bcube.vm[33][0] = 0;
  world.bcube.vm[33][1] = 1;
  world.bcube.vm[34][0] = 1;
  world.bcube.vm[34][1] = 1;
  world.bcube.vm[35][0] = 1;
  world.bcube.vm[35][1] = 0;

}



void initCubeMap(void) {
  for (i=0; i<6; i++) {
    glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT + i,
      0, // level
      GL_RGB8, // internal format
      256, // width
      256, // height
      0, // border
      GL_RGBA, // format
      GL_UNSIGNED_BYTE, // type
      &cubemap_[i][0][0][0]); // pixel data
  }
  
  // Build mipmaps
  //gluBuild2DMipmaps(GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT, GL_RGB8, 64, 64, GL_RGB, GL_UNSIGNED_BYTE, &face[1][0][0][0]);

  //glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	//glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	//glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_R, GL_CLAMP_TO_EDGE);

  
}

/**
 * Return: 1 if extension is supported
 *         0 if extension is not supported
 *         -1 on error
 */
int isExtensionSupported(const char *extension)
{
  const GLubyte *extensions = NULL;
  const GLubyte *start;
  GLubyte *where, *terminator;

  /* Extension names should not have spaces. */
  where = (GLubyte *) strchr(extension, ' ');
  if (where || *extension == '\0')
    return 0;

  extensions = glGetString(GL_EXTENSIONS);
  if (extensions == 0) return -1;

  /* It takes a bit of care to be fool-proof about parsing the
     OpenGL extensions string.  Don't be fooled by sub-strings,
     etc. */
  start = extensions;
  for (;;) {
    where = (GLubyte *) strstr((const char *) start, extension);
    if (!where)
      break;
    terminator = where + strlen(extension);
    if (where == start || *(where - 1) == ' ')
      if (*terminator == ' ' || *terminator == '\0')
        return 1;
    start = terminator;
  }
  return 0;
}
